diff --git a/collects/racket/extflonum.rkt b/collects/racket/extflonum.rkt
index ff3e730..6526245 100644
--- a/collects/racket/extflonum.rkt
+++ b/collects/racket/extflonum.rkt
@@ -40,4 +40,4 @@
   for/extflvector
   for*/extflvector
   extflvector-copy
-  0.0L0)
+  0.0T0)
diff --git a/collects/tests/racket/extfl-unsafe.rktl b/collects/tests/racket/extfl-unsafe.rktl
index 9afb546..c39369a 100644
--- a/collects/tests/racket/extfl-unsafe.rktl
+++ b/collects/tests/racket/extfl-unsafe.rktl
@@ -53,79 +53,79 @@
     (test result (eval `(lambda (x) (,proc x))) x)
     (test result (eval `(lambda () (,proc ',x)))))
 
-  (test-bin 3.4l0 'unsafe-extfl+ 1.4l0 2.0l0)
-  (test-bin -1.0999999999999999999l0 'unsafe-extfl+ 1.0l0 -2.1l0)
-  (test-bin +inf.l 'unsafe-extfl+ 1.0l0 +inf.l)
-  (test-bin -inf.l 'unsafe-extfl+ 1.0l0 -inf.l)
-  (test-bin +nan.l 'unsafe-extfl+ +nan.l -inf.l)
-  (test-bin 1.5l0 'unsafe-extfl+ 1.5l0 0.0l0)
-  (test-bin 1.7l0 'unsafe-extfl+ 0.0l0 1.7l0)
-
-  (test-bin 7.9l0 'unsafe-extfl- 10.0l0 2.1l0)
-  (test-bin 3.7l0 'unsafe-extfl- 1.0l0 -2.7l0)
-  (test-bin 1.5l0 'unsafe-extfl- 1.5l0 0.0l0)
-
-  (test-bin 20.002l0 'unsafe-extfl* 10.001l0 2.0l0)
-  (test-bin -20.002l0 'unsafe-extfl* 10.001l0 -2.0l0)
-  (test-bin +nan.l 'unsafe-extfl* +inf.l 0.0l0)
-  (test-bin 1.8l0 'unsafe-extfl* 1.0l0 1.8l0)
-  (test-bin 1.81l0 'unsafe-extfl* 1.81l0 1.0l0)
+  (test-bin 3.4t0 'unsafe-extfl+ 1.4t0 2.0t0)
+  (test-bin -1.0999999999999999999t0 'unsafe-extfl+ 1.0t0 -2.1t0)
+  (test-bin +inf.t 'unsafe-extfl+ 1.0t0 +inf.t)
+  (test-bin -inf.t 'unsafe-extfl+ 1.0t0 -inf.t)
+  (test-bin +nan.t 'unsafe-extfl+ +nan.t -inf.t)
+  (test-bin 1.5t0 'unsafe-extfl+ 1.5t0 0.0t0)
+  (test-bin 1.7t0 'unsafe-extfl+ 0.0t0 1.7t0)
+
+  (test-bin 7.9t0 'unsafe-extfl- 10.0t0 2.1t0)
+  (test-bin 3.7t0 'unsafe-extfl- 1.0t0 -2.7t0)
+  (test-bin 1.5t0 'unsafe-extfl- 1.5t0 0.0t0)
+
+  (test-bin 20.002t0 'unsafe-extfl* 10.001t0 2.0t0)
+  (test-bin -20.002t0 'unsafe-extfl* 10.001t0 -2.0t0)
+  (test-bin +nan.t 'unsafe-extfl* +inf.t 0.0t0)
+  (test-bin 1.8t0 'unsafe-extfl* 1.0t0 1.8t0)
+  (test-bin 1.81t0 'unsafe-extfl* 1.81t0 1.0t0)
   
-  (test-bin (exact->long-double-inexact 17/5) 'unsafe-extfl/ 17.0l0 5.0l0)
-  (test-bin +inf.l 'unsafe-extfl/ 17.0l0 0.0l0)
-  (test-bin -inf.l 'unsafe-extfl/ -17.0l0 0.0l0)
-  (test-bin 1.5l0 'unsafe-extfl/ 1.5l0 1.0l0)
-
-  (test-un 5.0l0 unsafe-extflabs 5.0l0)
-  (test-un 5.0l0 unsafe-extflabs -5.0l0)
-  (test-un 0.0l0 unsafe-extflabs -0.0l0)
-  (test-un +inf.l unsafe-extflabs -inf.l)
-
-  (test-un 5.0l0 unsafe-extflsqrt 25.0l0)
-  (test-un 0.5l0 unsafe-extflsqrt 0.25l0)
-  (test-un +nan.l unsafe-extflsqrt -1.0l0)
-
-  (test-un 8.0l0 'unsafe-fx->extfl 8)
-  (test-un -8.0l0 'unsafe-fx->extfl -8)
-
-  (test-un 8 'unsafe-extfl->fx 8.0l0)
-  (test-un -8 'unsafe-extfl->fx -8.0l0)
-
-  (test-bin 3.7l0 'unsafe-extflmin 3.7l0 4.1l0)
-  (test-bin 2.1l0 'unsafe-extflmin 3.7l0 2.1l0)
-  (test-bin +nan.l 'unsafe-extflmin +nan.l 2.1l0)
-  (test-bin +nan.l 'unsafe-extflmin 2.1l0 +nan.l)
-  (test-bin 3.7l0 'unsafe-extflmax 3.7l0 2.1l0)
-  (test-bin 4.1l0 'unsafe-extflmax 3.7l0 4.1l0)
-  (test-bin +nan.l 'unsafe-extflmax +nan.l 2.1l0)
-  (test-bin +nan.l 'unsafe-extflmax 2.1l0 +nan.l)
+  (test-bin (exact->long-double-inexact 17/5) 'unsafe-extfl/ 17.0t0 5.0t0)
+  (test-bin +inf.t 'unsafe-extfl/ 17.0t0 0.0t0)
+  (test-bin -inf.t 'unsafe-extfl/ -17.0t0 0.0t0)
+  (test-bin 1.5t0 'unsafe-extfl/ 1.5t0 1.0t0)
+
+  (test-un 5.0t0 unsafe-extflabs 5.0t0)
+  (test-un 5.0t0 unsafe-extflabs -5.0t0)
+  (test-un 0.0t0 unsafe-extflabs -0.0t0)
+  (test-un +inf.t unsafe-extflabs -inf.t)
+
+  (test-un 5.0t0 unsafe-extflsqrt 25.0t0)
+  (test-un 0.5t0 unsafe-extflsqrt 0.25t0)
+  (test-un +nan.t unsafe-extflsqrt -1.0t0)
+
+  (test-un 8.0t0 'unsafe-fx->extfl 8)
+  (test-un -8.0t0 'unsafe-fx->extfl -8)
+
+  (test-un 8 'unsafe-extfl->fx 8.0t0)
+  (test-un -8 'unsafe-extfl->fx -8.0t0)
+
+  (test-bin 3.7t0 'unsafe-extflmin 3.7t0 4.1t0)
+  (test-bin 2.1t0 'unsafe-extflmin 3.7t0 2.1t0)
+  (test-bin +nan.t 'unsafe-extflmin +nan.t 2.1t0)
+  (test-bin +nan.t 'unsafe-extflmin 2.1t0 +nan.t)
+  (test-bin 3.7t0 'unsafe-extflmax 3.7t0 2.1t0)
+  (test-bin 4.1t0 'unsafe-extflmax 3.7t0 4.1t0)
+  (test-bin +nan.t 'unsafe-extflmax +nan.t 2.1t0)
+  (test-bin +nan.t 'unsafe-extflmax 2.1t0 +nan.t)
 
   ;; test unboxing:
-  (test-tri 9.0l0 '(lambda (x y z) (unsafe-extfl+ (unsafe-extfl- x z) y)) 4.5l0 7.0l0 2.5l0)
-  (test-tri 9.0l0 '(lambda (x y z) (unsafe-extfl+ y (unsafe-extfl- x z))) 4.5l0 7.0l0 2.5l0)
-  (test-bin 10.0l0 '(lambda (x y) (unsafe-extfl+ (unsafe-fx->extfl x) y)) 2 8.0l0)
-  (test-bin 10.0l0 '(lambda (x y) (unsafe-extfl+ (unsafe-fx->extfl x) y)) 2 8.0l0)
-  (test-bin 9.5l0 '(lambda (x y) (unsafe-extfl+ (unsafe-extflabs x) y)) -2.0l0 7.5l0)
-  (test-tri (unsafe-extfl/ 20.0l0 0.8l0) '(lambda (x y z) (unsafe-extfl/ (unsafe-extfl* x z) y)) 4.0l0 0.8l0 5.0l0)
-  (test-tri (unsafe-extfl/ 0.8l0 20.0l0) '(lambda (x y z) (unsafe-extfl/ y (unsafe-extfl* x z))) 4.0l0 0.8l0 5.0l0)
-
-  (test-tri #t '(lambda (x y z) (unsafe-extfl< (unsafe-extfl+ x y) z)) 1.2l0 3.4l0 5.0l0)
-  (test-tri 'yes '(lambda (x y z) (if (unsafe-extfl< (unsafe-extfl+ x y) z) 'yes 'no)) 1.2l0 3.4l0 5.0l0)
-  (test-tri #f '(lambda (x y z) (unsafe-extfl> (unsafe-extfl+ x y) z)) 1.2l0 3.4l0 5.0l0)
-  (test-tri 'no '(lambda (x y z) (if (unsafe-extfl> (unsafe-extfl+ x y) z) 'yes 'no)) 1.2l0 3.4l0 5.0l0)
+  (test-tri 9.0t0 '(lambda (x y z) (unsafe-extfl+ (unsafe-extfl- x z) y)) 4.5t0 7.0t0 2.5t0)
+  (test-tri 9.0t0 '(lambda (x y z) (unsafe-extfl+ y (unsafe-extfl- x z))) 4.5t0 7.0t0 2.5t0)
+  (test-bin 10.0t0 '(lambda (x y) (unsafe-extfl+ (unsafe-fx->extfl x) y)) 2 8.0t0)
+  (test-bin 10.0t0 '(lambda (x y) (unsafe-extfl+ (unsafe-fx->extfl x) y)) 2 8.0t0)
+  (test-bin 9.5t0 '(lambda (x y) (unsafe-extfl+ (unsafe-extflabs x) y)) -2.0t0 7.5t0)
+  (test-tri (unsafe-extfl/ 20.0t0 0.8t0) '(lambda (x y z) (unsafe-extfl/ (unsafe-extfl* x z) y)) 4.0t0 0.8t0 5.0t0)
+  (test-tri (unsafe-extfl/ 0.8t0 20.0t0) '(lambda (x y z) (unsafe-extfl/ y (unsafe-extfl* x z))) 4.0t0 0.8t0 5.0t0)
+
+  (test-tri #t '(lambda (x y z) (unsafe-extfl< (unsafe-extfl+ x y) z)) 1.2t0 3.4t0 5.0t0)
+  (test-tri 'yes '(lambda (x y z) (if (unsafe-extfl< (unsafe-extfl+ x y) z) 'yes 'no)) 1.2t0 3.4t0 5.0t0)
+  (test-tri #f '(lambda (x y z) (unsafe-extfl> (unsafe-extfl+ x y) z)) 1.2t0 3.4t0 5.0t0)
+  (test-tri 'no '(lambda (x y z) (if (unsafe-extfl> (unsafe-extfl+ x y) z) 'yes 'no)) 1.2t0 3.4t0 5.0t0)
   
   ;; test unboxing interaction with free variables:
-  (test-tri 4.4l0 '(lambda (x y z) (with-handlers ([exn:fail:contract:variable? 
+  (test-tri 4.4t0 '(lambda (x y z) (with-handlers ([exn:fail:contract:variable? 
                                                   (lambda (exn) (unsafe-extfl+ x y))])
                                    (unsafe-extfl- (unsafe-extfl+ x y) NO-SUCH-VARIABLE)))
-            1.1l0 3.3l0 5.2l0)
+            1.1t0 3.3t0 5.2t0)
 
 
-  (test-bin 9.5l0 'unsafe-extflvector-ref (extflvector 1.0l0 9.5l0 18.7l0) 1)
-  (test-un 5 'unsafe-extflvector-length (extflvector 1.1l0 2.0l0 3.1l0 4.5l0 5.7l0))
-  (let ([v (extflvector 1.0l0 9.5l0 18.7l0)])
-    (test-tri (list (void) 27.4l0) 'unsafe-extflvector-set! v 2 27.4l0
-              #:pre (lambda () (extflvector-set! v 2 0.0l0))
+  (test-bin 9.5t0 'unsafe-extflvector-ref (extflvector 1.0t0 9.5t0 18.7t0) 1)
+  (test-un 5 'unsafe-extflvector-length (extflvector 1.1t0 2.0t0 3.1t0 4.5t0 5.7t0))
+  (let ([v (extflvector 1.0t0 9.5t0 18.7t0)])
+    (test-tri (list (void) 27.4t0) 'unsafe-extflvector-set! v 2 27.4t0
+              #:pre (lambda () (extflvector-set! v 2 0.0t0))
               #:post (lambda (x) (list x (extflvector-ref v 2)))
               #:literal-ok? #f))
 
@@ -135,25 +135,25 @@
 
 ;; Interaction of unboxing, closures, etc.
 (let ([f (lambda (x)
-           (let ([x (unsafe-extfl+ x 1.0l0)])
-             (let loop ([v 0.0l0][n 10000])
+           (let ([x (unsafe-extfl+ x 1.0t0)])
+             (let loop ([v 0.0t0][n 10000])
                (if (zero? n)
                    v
                    (loop (unsafe-extfl+ v x)
                          (- n 1))))))])
-  (test 20000.0l0 f 1.0l0))
+  (test 20000.0t0 f 1.0t0))
 (let ([f (lambda (x)
-           (let ([x (unsafe-extfl+ x 1.0l0)])
-             (let loop ([v 0.0l0][n 10000][q 2.0l0])
+           (let ([x (unsafe-extfl+ x 1.0t0)])
+             (let loop ([v 0.0t0][n 10000][q 2.0t0])
                (if (zero? n)
                    (unsafe-extfl+ v q)
                    (loop (unsafe-extfl+ v x)
                          (- n 1)
-                         (unsafe-extfl- 0.0l0 q))))))])
-  (test 20002.0l0 f 1.0l0))
+                         (unsafe-extfl- 0.0t0 q))))))])
+  (test 20002.0t0 f 1.0t0))
 
 (let ([f (lambda (x)
-           (let loop ([a 0.0l0][v 0.0l0][n 1000000])
+           (let loop ([a 0.0t0][v 0.0t0][n 1000000])
              (if (zero? n)
                  v
                  (if (odd? n)
@@ -163,7 +163,7 @@
                      (loop a
                            (unsafe-extfl+ v x)
                            (- n 1))))))])
-  (test 1000000.0l0 f 2.0l0))
+  (test 1000000.0t0 f 2.0t0))
 
 ;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
@@ -181,7 +181,7 @@
                  )
             (get-M) ; triggers safe-for-space clearing of M
             N1)))
-  (test 15388.0l0 unsafe-extflfloor (unsafe-extfl* 1000.0l0 (weird (lambda () 64.0l0))))
+  (test 15388.0t0 unsafe-extflfloor (unsafe-extfl* 1000.0t0 (weird (lambda () 64.0t0))))
   )
 
 ;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
diff --git a/collects/tests/racket/extflonum.rktl b/collects/tests/racket/extflonum.rktl
index bf401ec..9f9c508 100644
--- a/collects/tests/racket/extflonum.rktl
+++ b/collects/tests/racket/extflonum.rktl
@@ -11,7 +11,7 @@
            (exact->long-double-inexact 1e-8)))
 
 ;; in-extflvector tests.
-(let ((flv (extflvector 1.0l0 2.0l0 3.0l0)))
+(let ((flv (extflvector 1.0t0 2.0t0 3.0t0)))
   (let ((flv-seq (in-extflvector flv)))
     (for ((x (in-extflvector flv))
           (xseq flv-seq)
@@ -20,47 +20,47 @@
       (test (->extfl (+ i 1)) 'in-extflvector-sequence xseq))))
 
 ;; for/extflvector test
-(let ((flv (extflvector 1.0l0 2.0l0 3.0l0))
+(let ((flv (extflvector 1.0t0 2.0t0 3.0t0))
       (flv1 (for/extflvector ((i (in-range 3))) (->extfl (+ i 1))))
       (flv2 (for/extflvector #:length 3 ((i (in-range 3))) (exact->long-double-inexact (+ i 1.0)))))
   (test flv 'for/extflvector flv1)
   (test flv 'for/extflvector-fast flv2))
 
-(test (extflvector 1.0l0 2.0l0 3.0l0 0.0l0 0.0l0)
+(test (extflvector 1.0t0 2.0t0 3.0t0 0.0t0 0.0t0)
       'for/extflvector-fill
       (for/extflvector #:length 5 ([i 3]) (exact->long-double-inexact (+ i 1.0))))
-(test (extflvector 1.0l0 2.0l0 3.0l0 -10.0l0 -10.0l0)
+(test (extflvector 1.0t0 2.0t0 3.0t0 -10.0t0 -10.0t0)
       'for/extflvector-fill
-      (for/extflvector #:length 5 #:fill -10.0l0 ([i 3]) (exact->long-double-inexact (+ i 1.0))))
-(test (extflvector 1.0l0 2.0l0 3.0l0 0.0l0 0.0l0)
+      (for/extflvector #:length 5 #:fill -10.0t0 ([i 3]) (exact->long-double-inexact (+ i 1.0))))
+(test (extflvector 1.0t0 2.0t0 3.0t0 0.0t0 0.0t0)
       'for/extflvector-fill
       (for/extflvector #:length 5 ([i 5]) #:break (= i 3) (exact->long-double-inexact (+ i 1.0))))
-(test (extflvector 1.0l0 2.0l0 3.0l0 4.0l0 0.0l0)
+(test (extflvector 1.0t0 2.0t0 3.0t0 4.0t0 0.0t0)
       'for/extflvector-fill
       (for/extflvector #:length 5 ([i 5]) #:final (= i 3) (exact->long-double-inexact (+ i 1.0))))
 
 ;; for*/extflvector test
-(let ((flv (extflvector 0.0l0 0.0l0 0.0l0 0.0l0 1.0l0 2.0l0 0.0l0 2.0l0 4.0l0))
+(let ((flv (extflvector 0.0t0 0.0t0 0.0t0 0.0t0 1.0t0 2.0t0 0.0t0 2.0t0 4.0t0))
       (flv1 (for*/extflvector ((i (in-range 3)) (j (in-range 3))) (->extfl (* 1 i j))))
       (flv2 (for*/extflvector #:length 9 ((i (in-range 3)) (j (in-range 3))) (exact->long-double-inexact (* 1.0 i j)))))
   (test flv 'for*/extflvector flv1)
   (test flv 'for*/extflvector-fast flv2))
 
 ;; Stop when a length is specified, even if the sequence continues:
-(test (extflvector 0.0l0 1.0l0 2.0l0 3.0l0 4.0l0 5.0l0 6.0l0 7.0l0 8.0l0 9.0l0)
+(test (extflvector 0.0t0 1.0t0 2.0t0 3.0t0 4.0t0 5.0t0 6.0t0 7.0t0 8.0t0 9.0t0)
       'nat
       (for/extflvector #:length 10 ([i (in-naturals)]) (exact->long-double-inexact i)))
-(test (extflvector 0.0l0 1.0l0 2.0l0 3.0l0 4.0l0 5.0l0 6.0l0 7.0l0 8.0l0 9.0l0)
+(test (extflvector 0.0t0 1.0t0 2.0t0 3.0t0 4.0t0 5.0t0 6.0t0 7.0t0 8.0t0 9.0t0)
       'nats
       (for*/extflvector #:length 10 ([i (in-naturals)] [j (in-naturals)]) (exact->long-double-inexact j)))
-(test (extflvector 0.0l0 0.0l0 0.0l0 0.0l0 0.0l0 1.0l0 1.0l0 1.0l0 1.0l0 1.0l0)
+(test (extflvector 0.0t0 0.0t0 0.0t0 0.0t0 0.0t0 1.0t0 1.0t0 1.0t0 1.0t0 1.0t0)
       'nat+5
       (for*/extflvector #:length 10 ([i (in-naturals)] [j (in-range 5)]) (exact->long-double-inexact i)))
 
 ;; Test for both length too long and length too short
 (let ((v (make-extflvector 3)))
-  (extflvector-set! v 0 0.0l0)
-  (extflvector-set! v 1 1.0l0)
+  (extflvector-set! v 0 0.0t0)
+  (extflvector-set! v 1 1.0t0)
   (let ((w (for/extflvector #:length 3 ((i (in-range 2))) (exact->long-double-inexact i))))
     (test v 'for/extflvector-short-iter w)))
 
@@ -77,61 +77,61 @@
       (extflvector-length (for*/extflvector #:length 5 ((i (in-range 3)) (j (in-range 3))) (exact->long-double-inexact (+ i j)))))
 
 ;; Test for many body expressions
-(let* ((flv (extflvector 1.0l0 2.0l0 3.0l0))
+(let* ((flv (extflvector 1.0t0 2.0t0 3.0t0))
        (flv2 (for/extflvector ((i (in-range 3))) 
-               (extflvector-set! flv i (extfl+ (extflvector-ref flv i) 1.0l0))
+               (extflvector-set! flv i (extfl+ (extflvector-ref flv i) 1.0t0))
                (extflvector-ref flv i)))
        (flv3 (for/extflvector #:length 3 ((i (in-range 3)))
-               (extflvector-set! flv i (extfl+ (extflvector-ref flv i) 1.0l0))
+               (extflvector-set! flv i (extfl+ (extflvector-ref flv i) 1.0t0))
                (extflvector-ref flv i))))
-  (test (extflvector 2.0l0 3.0l0 4.0l0) 'for/extflvector-many-body flv2)
-  (test (extflvector 3.0l0 4.0l0 5.0l0) 'for/extflvector-length-many-body flv3))
+  (test (extflvector 2.0t0 3.0t0 4.0t0) 'for/extflvector-many-body flv2)
+  (test (extflvector 3.0t0 4.0t0 5.0t0) 'for/extflvector-length-many-body flv3))
 
 ;; extflvector-copy test
-(let ((v (extflvector 0.0l0 1.0l0 2.0l0 3.0l0)))
+(let ((v (extflvector 0.0t0 1.0t0 2.0t0 3.0t0)))
   (let ((vc (extflvector-copy v)))
     (test (extflvector-length v) 'extflvector-copy (extflvector-length vc))
     (for ((vx (in-extflvector v))
           (vcx (in-extflvector vc)))
       (test vx 'extflvector-copy vcx))
-    (extflvector-set! vc 2 -10.0l0)
-    (test 2.0l0 'extflvector-copy (extflvector-ref v 2))
-    (test -10.0l0 'extflvector-copy (extflvector-ref vc 2))
-    (test '(2.0l0 3.0l0) 'extflvector-copy (for/list ([i (in-extflvector (extflvector-copy v 2))]) i))
-    (test '(2.0l0) 'extflvector-copy (for/list ([i (in-extflvector (extflvector-copy v 2 3))]) i))))
+    (extflvector-set! vc 2 -10.0t0)
+    (test 2.0t0 'extflvector-copy (extflvector-ref v 2))
+    (test -10.0t0 'extflvector-copy (extflvector-ref vc 2))
+    (test '(2.0t0 3.0t0) 'extflvector-copy (for/list ([i (in-extflvector (extflvector-copy v 2))]) i))
+    (test '(2.0t0) 'extflvector-copy (for/list ([i (in-extflvector (extflvector-copy v 2 3))]) i))))
 
 ;; Check empty clauses
 (let ()
   (define vector-iters 0)
-  (test (extflvector 3.4l0 0.0l0 0.0l0 0.0l0)
+  (test (extflvector 3.4t0 0.0t0 0.0t0 0.0t0)
         'no-clauses
         (for/extflvector #:length 4 ()
                       (set! vector-iters (+ 1 vector-iters))
-                      3.4l0))
+                      3.4t0))
   (test 1 values vector-iters)
-  (test (extflvector 3.4l0 0.0l0 0.0l0 0.0l0)
+  (test (extflvector 3.4t0 0.0t0 0.0t0 0.0t0)
         'no-clauses
         (for*/extflvector #:length 4 ()
                        (set! vector-iters (+ 1 vector-iters))
-                       3.4l0))
+                       3.4t0))
   (test 2 values vector-iters))
 
 ;; Check #:when and #:unless:
-(test (extflvector 0.0l0 1.0l0 2.0l0 1.0l0 2.0l0)
+(test (extflvector 0.0t0 1.0t0 2.0t0 1.0t0 2.0t0)
       'when-#t
       (for/extflvector #:length 5
                     ([x (in-range 3)]
                      #:when #t
                      [y (in-range 3)])
          (exact->long-double-inexact (+ x y))))
-(test (extflvector 0.0l0 1.0l0 2.0l0 2.0l0 3.0l0)
+(test (extflvector 0.0t0 1.0t0 2.0t0 2.0t0 3.0t0)
       'when-...
       (for/extflvector #:length 5
                     ([x (in-range 3)]
                      #:when (even? x)
                      [y (in-range 3)])
         (exact->long-double-inexact (+ x y))))
-(test (extflvector 0.0l0 1.0l0 2.0l0 1.0l0 2.0l0)
+(test (extflvector 0.0t0 1.0t0 2.0t0 1.0t0 2.0t0)
       'unless-#f
       (for/extflvector #:length 5
                     ([x (in-range 3)]
@@ -139,7 +139,7 @@
                      [y (in-range 3)])
         (exact->long-double-inexact (+ x y))))
 
-(test (extflvector 1.0l0 2.0l0 3.0l0 0.0l0 0.0l0)
+(test (extflvector 1.0t0 2.0t0 3.0t0 0.0t0 0.0t0)
       'unless-...
       (for/extflvector #:length 5
                     ([x (in-range 3)]
@@ -255,13 +255,13 @@
     [(_ seqs gen)
      (test-multi-sequence seqs gen)]))
 
-(test-sequence [(1.0l0 2.0l0 3.0l0)] (in-extflvector (extflvector 1.0l0 2.0l0 3.0l0)))
-(test-sequence [(2.0l0 3.0l0 4.0l0)] (in-extflvector (extflvector 1.0l0 2.0l0 3.0l0 4.0l0) 1))
-(test-sequence [(2.0l0 3.0l0 4.0l0)] (in-extflvector (extflvector 1.0l0 2.0l0 3.0l0 4.0l0 5.0l0) 1 4))
-(test-sequence [(2.0l0 4.0l0 6.0l0)] (in-extflvector (extflvector 1.0l0 2.0l0 3.0l0 4.0l0 5.0l0 6.0l0 7.0l0 8.0l0) 1 7 2))
-(test-sequence [(8.0l0 6.0l0 4.0l0)] (in-extflvector (extflvector 1.0l0 2.0l0 3.0l0 4.0l0 5.0l0 6.0l0 7.0l0 8.0l0) 7 1 -2))
-(test-sequence [(2.0l0 4.0l0 6.0l0)] (in-extflvector (extflvector 1.0l0 2.0l0 3.0l0 4.0l0 5.0l0 6.0l0 7.0l0 8.0l0) 1 6 2))
-(test-sequence [(8.0l0 6.0l0 4.0l0)] (in-extflvector (extflvector 1.0l0 2.0l0 3.0l0 4.0l0 5.0l0 6.0l0 7.0l0 8.0l0) 7 2 -2))
+(test-sequence [(1.0t0 2.0t0 3.0t0)] (in-extflvector (extflvector 1.0t0 2.0t0 3.0t0)))
+(test-sequence [(2.0t0 3.0t0 4.0t0)] (in-extflvector (extflvector 1.0t0 2.0t0 3.0t0 4.0t0) 1))
+(test-sequence [(2.0t0 3.0t0 4.0t0)] (in-extflvector (extflvector 1.0t0 2.0t0 3.0t0 4.0t0 5.0t0) 1 4))
+(test-sequence [(2.0t0 4.0t0 6.0t0)] (in-extflvector (extflvector 1.0t0 2.0t0 3.0t0 4.0t0 5.0t0 6.0t0 7.0t0 8.0t0) 1 7 2))
+(test-sequence [(8.0t0 6.0t0 4.0t0)] (in-extflvector (extflvector 1.0t0 2.0t0 3.0t0 4.0t0 5.0t0 6.0t0 7.0t0 8.0t0) 7 1 -2))
+(test-sequence [(2.0t0 4.0t0 6.0t0)] (in-extflvector (extflvector 1.0t0 2.0t0 3.0t0 4.0t0 5.0t0 6.0t0 7.0t0 8.0t0) 1 6 2))
+(test-sequence [(8.0t0 6.0t0 4.0t0)] (in-extflvector (extflvector 1.0t0 2.0t0 3.0t0 4.0t0 5.0t0 6.0t0 7.0t0 8.0t0) 7 2 -2))
 
 
 
@@ -274,116 +274,116 @@
     (test b extflexpt v1 v2))
   
   ;; 2^53 and every larger flonum is even:
-  (define +big-even.0l0 (extflexpt 2.0l0 53.0l0))
+  (define +big-even.0t0 (extflexpt 2.0t0 53.0t0))
   ;; The largest odd flonum:
-  (define +max-odd.0l0 (extfl- +big-even.0l0 1.0l0))
-
-  (define -big-even.0l0 (extfl- 0.0l0 +big-even.0l0))
-  (define -max-odd.0l0 (extfl- 0.0l0 +max-odd.0l0))
-
-  (check-equal? (extflexpt +0.0l0 +0.0l0) +1.0l0)
-  (check-equal? (extflexpt +0.0l0 +1.0l0) +0.0l0)
-  (check-equal? (extflexpt +0.0l0 +3.0l0) +0.0l0)
-  (check-equal? (extflexpt +0.0l0 +max-odd.0l0) +0.0l0)
-  (check-equal? (extflexpt +0.0l0 +0.5l0) +0.0l0)
-  (check-equal? (extflexpt +0.0l0 +1.5l0) +0.0l0)
-  (check-equal? (extflexpt +0.0l0 +2.0l0) +0.0l0)
-  (check-equal? (extflexpt +0.0l0 +2.5l0) +0.0l0)
-  (check-equal? (extflexpt +0.0l0 +big-even.0l0) +0.0l0)
-
-  (check-equal? (extflexpt -0.0l0 +0.0l0) +1.0l0)
-  (check-equal? (extflexpt -0.0l0 +1.0l0) -0.0l0)
-  (check-equal? (extflexpt -0.0l0 +3.0l0) -0.0l0)
-  (check-equal? (extflexpt -0.0l0 +max-odd.0l0) -0.0l0)
-  (check-equal? (extflexpt -0.0l0 +0.5l0) +0.0l0)
-  (check-equal? (extflexpt -0.0l0 +1.5l0) +0.0l0)
-  (check-equal? (extflexpt -0.0l0 +2.0l0) +0.0l0)
-  (check-equal? (extflexpt -0.0l0 +2.5l0) +0.0l0)
-  (check-equal? (extflexpt -0.0l0 +big-even.0l0) +0.0l0)
-
-  (check-equal? (extflexpt +1.0l0 +0.0l0) +1.0l0)
-  (check-equal? (extflexpt +1.0l0 +0.5l0) +1.0l0)
-  (check-equal? (extflexpt +1.0l0 +inf.l) +1.0l0)
-
-  (check-equal? (extflexpt -1.0l0 +0.0l0) +1.0l0)
-  (check-equal? (extflexpt -1.0l0 +0.5l0) +nan.l)
-  (check-equal? (extflexpt -1.0l0 +inf.l) +1.0l0)
-
-  (check-equal? (extflexpt +0.5l0 +inf.l) +0.0l0)
-  (check-equal? (extflexpt +1.5l0 +inf.l) +inf.l)
-
-  (check-equal? (extflexpt +inf.l +0.0l0) +1.0l0)
-  (check-equal? (extflexpt +inf.l +1.0l0) +inf.l)
-  (check-equal? (extflexpt +inf.l +2.0l0) +inf.l)
-  (check-equal? (extflexpt +inf.l +inf.l) +inf.l)
-
-  (check-equal? (extflexpt -inf.l +0.0l0) +1.0l0)
-  (check-equal? (extflexpt -inf.l +1.0l0) -inf.l)
-  (check-equal? (extflexpt -inf.l +3.0l0) -inf.l)
-  (check-equal? (extflexpt -inf.l +max-odd.0l0) -inf.l)
-  (check-equal? (extflexpt -inf.l +0.5l0) +inf.l)
-  (check-equal? (extflexpt -inf.l +1.5l0) +inf.l)
-  (check-equal? (extflexpt -inf.l +2.0l0) +inf.l)
-  (check-equal? (extflexpt -inf.l +2.5l0) +inf.l)
-  (check-equal? (extflexpt -inf.l +big-even.0l0) +inf.l)
-  (check-equal? (extflexpt -inf.l +inf.l) +inf.l)
+  (define +max-odd.0t0 (extfl- +big-even.0t0 1.0t0))
+
+  (define -big-even.0t0 (extfl- 0.0t0 +big-even.0t0))
+  (define -max-odd.0t0 (extfl- 0.0t0 +max-odd.0t0))
+
+  (check-equal? (extflexpt +0.0t0 +0.0t0) +1.0t0)
+  (check-equal? (extflexpt +0.0t0 +1.0t0) +0.0t0)
+  (check-equal? (extflexpt +0.0t0 +3.0t0) +0.0t0)
+  (check-equal? (extflexpt +0.0t0 +max-odd.0t0) +0.0t0)
+  (check-equal? (extflexpt +0.0t0 +0.5t0) +0.0t0)
+  (check-equal? (extflexpt +0.0t0 +1.5t0) +0.0t0)
+  (check-equal? (extflexpt +0.0t0 +2.0t0) +0.0t0)
+  (check-equal? (extflexpt +0.0t0 +2.5t0) +0.0t0)
+  (check-equal? (extflexpt +0.0t0 +big-even.0t0) +0.0t0)
+
+  (check-equal? (extflexpt -0.0t0 +0.0t0) +1.0t0)
+  (check-equal? (extflexpt -0.0t0 +1.0t0) -0.0t0)
+  (check-equal? (extflexpt -0.0t0 +3.0t0) -0.0t0)
+  (check-equal? (extflexpt -0.0t0 +max-odd.0t0) -0.0t0)
+  (check-equal? (extflexpt -0.0t0 +0.5t0) +0.0t0)
+  (check-equal? (extflexpt -0.0t0 +1.5t0) +0.0t0)
+  (check-equal? (extflexpt -0.0t0 +2.0t0) +0.0t0)
+  (check-equal? (extflexpt -0.0t0 +2.5t0) +0.0t0)
+  (check-equal? (extflexpt -0.0t0 +big-even.0t0) +0.0t0)
+
+  (check-equal? (extflexpt +1.0t0 +0.0t0) +1.0t0)
+  (check-equal? (extflexpt +1.0t0 +0.5t0) +1.0t0)
+  (check-equal? (extflexpt +1.0t0 +inf.t) +1.0t0)
+
+  (check-equal? (extflexpt -1.0t0 +0.0t0) +1.0t0)
+  (check-equal? (extflexpt -1.0t0 +0.5t0) +nan.t)
+  (check-equal? (extflexpt -1.0t0 +inf.t) +1.0t0)
+
+  (check-equal? (extflexpt +0.5t0 +inf.t) +0.0t0)
+  (check-equal? (extflexpt +1.5t0 +inf.t) +inf.t)
+
+  (check-equal? (extflexpt +inf.t +0.0t0) +1.0t0)
+  (check-equal? (extflexpt +inf.t +1.0t0) +inf.t)
+  (check-equal? (extflexpt +inf.t +2.0t0) +inf.t)
+  (check-equal? (extflexpt +inf.t +inf.t) +inf.t)
+
+  (check-equal? (extflexpt -inf.t +0.0t0) +1.0t0)
+  (check-equal? (extflexpt -inf.t +1.0t0) -inf.t)
+  (check-equal? (extflexpt -inf.t +3.0t0) -inf.t)
+  (check-equal? (extflexpt -inf.t +max-odd.0t0) -inf.t)
+  (check-equal? (extflexpt -inf.t +0.5t0) +inf.t)
+  (check-equal? (extflexpt -inf.t +1.5t0) +inf.t)
+  (check-equal? (extflexpt -inf.t +2.0t0) +inf.t)
+  (check-equal? (extflexpt -inf.t +2.5t0) +inf.t)
+  (check-equal? (extflexpt -inf.t +big-even.0t0) +inf.t)
+  (check-equal? (extflexpt -inf.t +inf.t) +inf.t)
 
   ;; Same tests as above, but with negated y
-  ;; This identity should hold for these tests: (extflexpt x y) = (/ 1.0l0 (extflexpt x (- y)))
-
-  (check-equal? (extflexpt +0.0l0 -0.0l0) +1.0l0)
-  (check-equal? (extflexpt +0.0l0 -1.0l0) +inf.l)
-  (check-equal? (extflexpt +0.0l0 -3.0l0) +inf.l)
-  (check-equal? (extflexpt +0.0l0 -max-odd.0l0) +inf.l)
-  (check-equal? (extflexpt +0.0l0 -0.5l0) +inf.l)
-  (check-equal? (extflexpt +0.0l0 -1.5l0) +inf.l)
-  (check-equal? (extflexpt +0.0l0 -2.0l0) +inf.l)
-  (check-equal? (extflexpt +0.0l0 -2.5l0) +inf.l)
-  (check-equal? (extflexpt +0.0l0 -big-even.0l0) +inf.l)
-
-  (check-equal? (extflexpt -0.0l0 -0.0l0) +1.0l0)
-  (check-equal? (extflexpt -0.0l0 -1.0l0) -inf.l)
-  (check-equal? (extflexpt -0.0l0 -3.0l0) -inf.l)
-  (check-equal? (extflexpt -0.0l0 -max-odd.0l0) -inf.l)
-  (check-equal? (extflexpt -0.0l0 -0.5l0) +inf.l)
-  (check-equal? (extflexpt -0.0l0 -1.5l0) +inf.l)
-  (check-equal? (extflexpt -0.0l0 -2.0l0) +inf.l)
-  (check-equal? (extflexpt -0.0l0 -2.5l0) +inf.l)
-  (check-equal? (extflexpt -0.0l0 -big-even.0l0) +inf.l)
-
-  (check-equal? (extflexpt +1.0l0 -0.0l0) +1.0l0)
-  (check-equal? (extflexpt +1.0l0 -0.5l0) +1.0l0)
-  (check-equal? (extflexpt +1.0l0 -inf.l) +1.0l0)
-
-  (check-equal? (extflexpt -1.0l0 -0.0l0) +1.0l0)
-  (check-equal? (extflexpt -1.0l0 -0.5l0) +nan.l)
-  (check-equal? (extflexpt -1.0l0 -inf.l) +1.0l0)
-
-  (check-equal? (extflexpt +0.5l0 -inf.l) +inf.l)
-  (check-equal? (extflexpt +1.5l0 -inf.l) +0.0l0)
-
-  (check-equal? (extflexpt +inf.l -0.0l0) +1.0l0)
-  (check-equal? (extflexpt +inf.l -1.0l0) +0.0l0)
-  (check-equal? (extflexpt +inf.l -2.0l0) +0.0l0)
-  (check-equal? (extflexpt +inf.l -inf.l) +0.0l0)
-
-  (check-equal? (extflexpt -inf.l -0.0l0) +1.0l0)
-  (check-equal? (extflexpt -inf.l -1.0l0) -0.0l0)
-  (check-equal? (extflexpt -inf.l -3.0l0) -0.0l0)
-  (check-equal? (extflexpt -inf.l -max-odd.0l0) -0.0l0)
-  (check-equal? (extflexpt -inf.l -0.5l0) +0.0l0)
-  (check-equal? (extflexpt -inf.l -1.5l0) +0.0l0)
-  (check-equal? (extflexpt -inf.l -2.0l0) +0.0l0)
-  (check-equal? (extflexpt -inf.l -2.5l0) +0.0l0)
-  (check-equal? (extflexpt -inf.l -big-even.0l0) +0.0l0)
-  (check-equal? (extflexpt -inf.l -inf.l) +0.0l0)
+  ;; This identity should hold for these tests: (extflexpt x y) = (/ 1.0t0 (extflexpt x (- y)))
+
+  (check-equal? (extflexpt +0.0t0 -0.0t0) +1.0t0)
+  (check-equal? (extflexpt +0.0t0 -1.0t0) +inf.t)
+  (check-equal? (extflexpt +0.0t0 -3.0t0) +inf.t)
+  (check-equal? (extflexpt +0.0t0 -max-odd.0t0) +inf.t)
+  (check-equal? (extflexpt +0.0t0 -0.5t0) +inf.t)
+  (check-equal? (extflexpt +0.0t0 -1.5t0) +inf.t)
+  (check-equal? (extflexpt +0.0t0 -2.0t0) +inf.t)
+  (check-equal? (extflexpt +0.0t0 -2.5t0) +inf.t)
+  (check-equal? (extflexpt +0.0t0 -big-even.0t0) +inf.t)
+
+  (check-equal? (extflexpt -0.0t0 -0.0t0) +1.0t0)
+  (check-equal? (extflexpt -0.0t0 -1.0t0) -inf.t)
+  (check-equal? (extflexpt -0.0t0 -3.0t0) -inf.t)
+  (check-equal? (extflexpt -0.0t0 -max-odd.0t0) -inf.t)
+  (check-equal? (extflexpt -0.0t0 -0.5t0) +inf.t)
+  (check-equal? (extflexpt -0.0t0 -1.5t0) +inf.t)
+  (check-equal? (extflexpt -0.0t0 -2.0t0) +inf.t)
+  (check-equal? (extflexpt -0.0t0 -2.5t0) +inf.t)
+  (check-equal? (extflexpt -0.0t0 -big-even.0t0) +inf.t)
+
+  (check-equal? (extflexpt +1.0t0 -0.0t0) +1.0t0)
+  (check-equal? (extflexpt +1.0t0 -0.5t0) +1.0t0)
+  (check-equal? (extflexpt +1.0t0 -inf.t) +1.0t0)
+
+  (check-equal? (extflexpt -1.0t0 -0.0t0) +1.0t0)
+  (check-equal? (extflexpt -1.0t0 -0.5t0) +nan.t)
+  (check-equal? (extflexpt -1.0t0 -inf.t) +1.0t0)
+
+  (check-equal? (extflexpt +0.5t0 -inf.t) +inf.t)
+  (check-equal? (extflexpt +1.5t0 -inf.t) +0.0t0)
+
+  (check-equal? (extflexpt +inf.t -0.0t0) +1.0t0)
+  (check-equal? (extflexpt +inf.t -1.0t0) +0.0t0)
+  (check-equal? (extflexpt +inf.t -2.0t0) +0.0t0)
+  (check-equal? (extflexpt +inf.t -inf.t) +0.0t0)
+
+  (check-equal? (extflexpt -inf.t -0.0t0) +1.0t0)
+  (check-equal? (extflexpt -inf.t -1.0t0) -0.0t0)
+  (check-equal? (extflexpt -inf.t -3.0t0) -0.0t0)
+  (check-equal? (extflexpt -inf.t -max-odd.0t0) -0.0t0)
+  (check-equal? (extflexpt -inf.t -0.5t0) +0.0t0)
+  (check-equal? (extflexpt -inf.t -1.5t0) +0.0t0)
+  (check-equal? (extflexpt -inf.t -2.0t0) +0.0t0)
+  (check-equal? (extflexpt -inf.t -2.5t0) +0.0t0)
+  (check-equal? (extflexpt -inf.t -big-even.0t0) +0.0t0)
+  (check-equal? (extflexpt -inf.t -inf.t) +0.0t0)
 
   ;; NaN input
 
-  (check-equal? (extflexpt +nan.l +0.0l0) +1.0l0)
-  (check-equal? (extflexpt +nan.l -0.0l0) +1.0l0)
-  (check-equal? (extflexpt +1.0l0 +nan.l) +1.0l0)
-  (check-equal? (extflexpt -1.0l0 +nan.l) +nan.l))
+  (check-equal? (extflexpt +nan.t +0.0t0) +1.0t0)
+  (check-equal? (extflexpt +nan.t -0.0t0) +1.0t0)
+  (check-equal? (extflexpt +1.0t0 +nan.t) +1.0t0)
+  (check-equal? (extflexpt -1.0t0 +nan.t) +nan.t))
 
 ;; ----------------------------------------
 
diff --git a/src/racket/src/jitarith.c b/src/racket/src/jitarith.c
index afe66d2..503a9d0 100644
--- a/src/racket/src/jitarith.c
+++ b/src/racket/src/jitarith.c
@@ -184,11 +184,11 @@ static int is_unboxing_immediate(Scheme_Object *obj, int unsafely)
   case scheme_local_type:
     if (SCHEME_GET_LOCAL_TYPE(obj) == SCHEME_LOCAL_TYPE_FLONUM)
       return 1;
-    return unsafely;
 #ifdef MZ_LONG_DOUBLE_DISABLED /* probably for unboxing */
     if (SCHEME_GET_LOCAL_TYPE(obj) == SCHEME_LOCAL_TYPE_EXTFLONUM)
       return 1;
 #endif
+    return unsafely;
   case scheme_toplevel_type:
     /* Can generalize to allow any toplevel if scheme_generate_pop_unboxed() is fixed */
     if ((SCHEME_TOPLEVEL_FLAGS(obj) & SCHEME_TOPLEVEL_FLAGS_MASK) < SCHEME_TOPLEVEL_READY)
@@ -560,23 +560,22 @@ int scheme_generate_alloc_long_double(mz_jit_state *jitter, int inline_retry, in
 }
 #endif
 
-#ifdef MZ_LONG_DOUBLE
-static int generate_long_double_arith(mz_jit_state *jitter, Scheme_Object *rator,
+static int generate_float_point_arith(mz_jit_state *jitter, Scheme_Object *rator,
                                       int arith, int cmp, int reversed, int two_args, int second_const,
                                       jit_insn **_refd, jit_insn **_refdt, Branch_Info *for_branch,
-                                      int branch_short, int unsafe_extfl, int unboxed, int unboxed_result,
-                                      int dest)
+                                      int branch_short, int unsafe_fl, int unboxed, int unboxed_result,
+                                      int dest, int call_for_extfl)
 /* Unless unboxed, first arg is in JIT_R1, second in JIT_R0.
    If unboxed in push/pop mode, first arg is pushed before second.
-   If unboxed in direct mode, first arg is in JIT_FPU_FPR0+depth
-   and second is in JIT_FPU_FPR1+depth (which is backward). 
+   If unboxed in direct mode, first arg is in JIT_FPR0+depth
+    and second is in JIT_FPR1+depth (which is backward). 
    Unboxed implies unsafe unless arith == ARITH_INEX_EX. */
 {
 #if defined(INLINE_FP_OPS) || defined(INLINE_FP_COMP)
   GC_CAN_IGNORE jit_insn *ref8, *ref9, *ref10, *refd, *refdt, *refs = NULL, *refs2 = NULL;
   int no_alloc = unboxed_result, need_post_pop = 0;
 
-  if (!unsafe_extfl && !unboxed) {
+  if (!unsafe_fl && !unboxed) {
     /* Maybe they're doubles */
     __START_TINY_JUMPS__(1);
     if (two_args) {
@@ -585,10 +584,16 @@ static int generate_long_double_arith(mz_jit_state *jitter, Scheme_Object *rator
     } else
       ref8 = NULL;
     jit_ldxi_s(JIT_R2, JIT_R0, &((Scheme_Object *)0x0)->type);
-    ref9 = jit_bnei_i(jit_forward(), JIT_R2, scheme_long_double_type);
+    if (call_for_extfl)
+      ref9 = jit_bnei_i(jit_forward(), JIT_R2, scheme_long_double_type);
+    else
+      ref9 = jit_bnei_i(jit_forward(), JIT_R2, scheme_double_type);
     if (two_args) {
       jit_ldxi_s(JIT_R2, JIT_R1, &((Scheme_Object *)0x0)->type);
-      ref10 = jit_bnei_i(jit_forward(), JIT_R2, scheme_long_double_type);
+      if (call_for_extfl)
+        ref10 = jit_bnei_i(jit_forward(), JIT_R2, scheme_long_double_type);
+      else
+        ref10 = jit_bnei_i(jit_forward(), JIT_R2, scheme_double_type);
     } else
       ref10 = NULL;
     CHECK_LIMIT();
@@ -606,12 +611,26 @@ static int generate_long_double_arith(mz_jit_state *jitter, Scheme_Object *rator
        right with stacks, that means pushing the second argument first. */
     int fpr1, fpr0;
 
-    fpr0 = JIT_FPU_FPR_0(jitter->unbox_depth);
-    fpr1 = JIT_FPU_FPR_1(1+jitter->unbox_depth);
-
+#ifdef MZ_LONG_DOUBLE
+    if (call_for_extfl) {
+      fpr0 = JIT_FPU_FPR_0(jitter->unbox_depth);
+      fpr1 = JIT_FPU_FPR_1(1+jitter->unbox_depth);
+    } else 
+#endif
+    {
+      fpr0 = JIT_FPR_0(jitter->unbox_depth);
+      fpr1 = JIT_FPR_1(1+jitter->unbox_depth);
+    }
+  
     if (two_args) {
-      if (!unboxed)
-        jit_fpu_ldxi_ld_fppush(fpr1, JIT_R1, &((Scheme_Long_Double *)0x0)->long_double_val);
+      if (!unboxed) {
+#ifdef MZ_LONG_DOUBLE
+        if (call_for_extfl)
+          jit_fpu_ldxi_ld_fppush(fpr1, JIT_R1, &((Scheme_Long_Double *)0x0)->long_double_val);
+        else
+#endif
+          jit_ldxi_d_fppush(fpr1, JIT_R1, &((Scheme_Double *)0x0)->double_val);
+      }
     } else if ((arith == ARITH_SUB) && !second_const && reversed) {
       reversed = 0;
     } else if (arith == ARITH_ABS) {
@@ -625,20 +644,33 @@ static int generate_long_double_arith(mz_jit_state *jitter, Scheme_Object *rator
     } else if (arith == ARITH_INEX_EX) {
       /* inexact->exact needs no extra number */
     } else {
-      long double d = second_const;
-      mz_fpu_movi_ld_fppush(fpr1, d, JIT_R2);
+#ifdef MZ_LONG_DOUBLE
+      if (call_for_extfl) {
+        long double ld = second_const;
+        mz_fpu_movi_ld_fppush(fpr1, ld, JIT_R2);
+      } else 
+#endif
+      {
+        double d = second_const;
+        mz_movi_d_fppush(fpr1, d, JIT_R2);
+      }
       reversed = !reversed;
       cmp = -cmp;
     }
 
     if (!unboxed) {
       if (arith != ARITH_EX_INEX) {
-        jit_fpu_ldxi_ld_fppush(fpr0, JIT_R0, &((Scheme_Long_Double *)0x0)->long_double_val);
+#ifdef MZ_LONG_DOUBLE
+        if (call_for_extfl)
+          jit_fpu_ldxi_ld_fppush(fpr0, JIT_R0, &((Scheme_Long_Double *)0x0)->long_double_val);
+        else
+#endif
+          jit_ldxi_d_fppush(fpr0, JIT_R0, &((Scheme_Double *)0x0)->double_val);
       }
     }
 
-#ifdef DIRECT_FPR_ACCESS_DISABLED /* sse only */
-    if (unboxed) {
+#ifdef DIRECT_FPR_ACCESS
+    if (unboxed && !call_for_extfl) {
       /* arguments are backward */
       reversed = !reversed;
       cmp = -cmp;
@@ -648,26 +680,56 @@ static int generate_long_double_arith(mz_jit_state *jitter, Scheme_Object *rator
     if (arith) {
       switch (arith) {
       case ARITH_ADD:
-        jit_fpu_addr_ld_fppop(fpr0, fpr0, fpr1);
+#ifdef MZ_LONG_DOUBLE
+        if (call_for_extfl)
+          jit_fpu_addr_ld_fppop(fpr0, fpr0, fpr1);
+        else
+#endif
+          jit_addr_d_fppop(fpr0, fpr0, fpr1);
         break;
       case ARITH_MUL:
-        jit_fpu_mulr_ld_fppop(fpr0, fpr0, fpr1);
+#ifdef MZ_LOND_DOUBLE
+        if (call_for_extfl)
+          jit_fpu_mulr_ld_fppop(fpr0, fpr0, fpr1);
+        else
+#endif
+          jit_mulr_d_fppop(fpr0, fpr0, fpr1);
         break;
       case ARITH_DIV:
-        if (!reversed)
-          jit_fpu_divrr_ld_fppop(fpr0, fpr0, fpr1);
+#ifdef MZ_LONG_DOUBLE
+        if (call_for_extfl)
+          if (!reversed)
+            jit_fpu_divrr_ld_fppop(fpr0, fpr0, fpr1);
+          else
+            jit_fpu_divr_ld_fppop(fpr0, fpr0, fpr1);
         else
-          jit_fpu_divr_ld_fppop(fpr0, fpr0, fpr1);
+#endif
+          if (!reversed)
+            jit_divrr_d_fppop(fpr0, fpr0, fpr1);
+          else
+            jit_divr_d_fppop(fpr0, fpr0, fpr1);
         break;
       case ARITH_SUB:
         {
-          if (!two_args && !second_const && !reversed) {
-            /* Need a special case to make sure that (- 0.0L) => -0.0L */
-            jit_fpu_negr_ld_fppop(fpr0, fpr0);
-          } else if (reversed)
-            jit_fpu_subr_ld_fppop(fpr0, fpr0, fpr1);
+#ifdef MZ_LONG_DOUBLE
+          if (call_for_extfl)
+            if (!two_args && !second_const && !reversed) {
+              /* Need a special case to make sure that (- 0.0) => -0.0 */
+              jit_fpu_negr_ld_fppop(fpr0, fpr0);
+            } else if (reversed)
+              jit_fpu_subr_ld_fppop(fpr0, fpr0, fpr1);
+            else
+              jit_fpu_subrr_ld_fppop(fpr0, fpr0, fpr1);
           else
-            jit_fpu_subrr_ld_fppop(fpr0, fpr0, fpr1);
+#endif
+            if (!two_args && !second_const && !reversed) {
+              /* Need a special case to make sure that (- 0.0) => -0.0 */
+              jit_negr_d_fppop(fpr0, fpr0);
+            } else if (reversed)
+              jit_subr_d_fppop(fpr0, fpr0, fpr1);
+            else
+              jit_subrr_d_fppop(fpr0, fpr0, fpr1);
+            
         }
         break;
       case ARITH_MIN:
@@ -675,31 +737,67 @@ static int generate_long_double_arith(mz_jit_state *jitter, Scheme_Object *rator
         {
           GC_CAN_IGNORE jit_insn *refc, *refn;
           __START_TINY_JUMPS__(1);
-	  /* If R0 is nan, then copy to R1, ensuring nan result */
-	  refn = jit_fpu_beqr_ld(jit_forward(), fpr0, fpr0);
-          if (unboxed)
-            jit_fpu_movr_ld_rel(fpr1, fpr0);
-          else
-            jit_movr_p(JIT_R1, JIT_R0);
-	  mz_patch_branch(refn);
-          if (arith == ARITH_MIN) {
-            if (unboxed) {
-              refc = jit_fpu_bltr_ld(jit_forward(), fpr0, fpr1);
+
+#ifdef MZ_LONG_DOUBLE
+          if (call_for_extfl) {
+                      
+            /* If R0 is nan, then copy to R1, ensuring nan result */
+            refn = jit_fpu_beqr_ld(jit_forward(), fpr0, fpr0);
+            if (unboxed)
+              jit_fpu_movr_ld_rel(fpr1, fpr0);
+            else
+              jit_movr_p(JIT_R1, JIT_R0);
+            mz_patch_branch(refn);
+            if (arith == ARITH_MIN) {
+              if (unboxed) {
+                refc = jit_fpu_bltr_ld(jit_forward(), fpr0, fpr1);
+              } else {
+                refc = jit_fpu_bltr_ld_fppop(jit_forward(), fpr0, fpr1);
+              }
             } else {
-              refc = jit_fpu_bltr_ld_fppop(jit_forward(), fpr0, fpr1);
+              if (unboxed) {
+                refc = jit_fpu_bger_ld(jit_forward(), fpr0, fpr1);
+              } else {
+                refc = jit_fpu_bger_ld_fppop(jit_forward(), fpr0, fpr1);
+              }
             }
-          } else {
             if (unboxed) {
-              refc = jit_fpu_bger_ld(jit_forward(), fpr0, fpr1);
+              jit_fpu_movr_ld_rel(fpr0, fpr1);
+              need_post_pop = 1;
+            } else
+              jit_movr_p(JIT_R0, JIT_R1);
+
+          } else 
+#endif
+          {
+          
+            /* If R0 is nan, then copy to R1, ensuring nan result */
+            refn = jit_beqr_d(jit_forward(), fpr0, fpr0);
+            if (unboxed)
+              jit_movr_d_rel(fpr1, fpr0);
+            else
+              jit_movr_p(JIT_R1, JIT_R0);
+            mz_patch_branch(refn);
+            if (arith == ARITH_MIN) {
+              if (unboxed) {
+                refc = jit_bltr_d(jit_forward(), fpr0, fpr1);
+              } else {
+                refc = jit_bltr_d_fppop(jit_forward(), fpr0, fpr1);
+              }
             } else {
-              refc = jit_fpu_bger_ld_fppop(jit_forward(), fpr0, fpr1);
+              if (unboxed) {
+                refc = jit_bger_d(jit_forward(), fpr0, fpr1);
+              } else {
+                refc = jit_bger_d_fppop(jit_forward(), fpr0, fpr1);
+              }
             }
+            if (unboxed) {
+              jit_movr_d_rel(fpr0, fpr1);
+              need_post_pop = 1;
+            } else
+              jit_movr_p(JIT_R0, JIT_R1);
           }
-          if (unboxed) {
-            jit_fpu_movr_ld_rel(fpr0, fpr1);
-            need_post_pop = 1;
-          } else
-            jit_movr_p(JIT_R0, JIT_R1);
+
           mz_patch_branch(refc);
           __END_TINY_JUMPS__(1);
           if (!unboxed) {
@@ -710,7 +808,12 @@ static int generate_long_double_arith(mz_jit_state *jitter, Scheme_Object *rator
         }
         break;
       case ARITH_ABS:
-        jit_fpu_abs_ld_fppop(fpr0, fpr0);
+#ifdef MZ_LONG_DOUBLE
+        if (call_for_extfl)
+          jit_fpu_abs_ld_fppop(fpr0, fpr0);
+        else
+#endif
+          jit_abs_d_fppop(fpr0, fpr0);
         break;
       case ARITH_EX_INEX: /* exact->inexact */
         /* no work to do, because argument is already inexact;
@@ -720,89 +823,174 @@ static int generate_long_double_arith(mz_jit_state *jitter, Scheme_Object *rator
         no_alloc = 1;
         break;
       case ARITH_INEX_EX: /* inexact->exact */
-        if (!unsafe_extfl) {
-          jit_fpu_movr_ld_fppush(fpr1, fpr0);
-        }
-        jit_fpu_roundr_ld_l_fppop(JIT_R1, fpr0);
-        if (!unsafe_extfl) {
-          /* to check whether it fits in a fixnum, we
-             need to convert back and check whether it
-             is the same */
-          if (unboxed)
-            jit_fpu_movr_ld_fppush(fpr1+1, fpr1); /* for slow path */
-          jit_fpu_extr_l_ld_fppush(fpr0, JIT_R1);
-          __START_TINY_JUMPS__(1);
-          refs = jit_fpu_bantieqr_ld_fppop(jit_forward(), fpr0, fpr1);
-          __END_TINY_JUMPS__(1);
-          /* result still may not fit in a fixnum */
-          jit_lshi_l(JIT_R2, JIT_R1, 1);
-          jit_rshi_l(JIT_R2, JIT_R2, 1);
-          __START_TINY_JUMPS__(1);
-          refs2 = jit_bner_l(jit_forward(), JIT_R1, JIT_R2);
-          __END_TINY_JUMPS__(1);
-#ifndef DIRECT_FPR_ACCESS_DISABLED
-          if (unboxed)
-            jit_fpu_roundr_ld_l_fppop(JIT_R1, fpr2); /* slow path won't be needed */
+#ifdef MZ_LONG_DOUBLE
+        if (call_for_extfl) {
+          if (!unsafe_fl) {
+            jit_fpu_movr_ld_fppush(fpr1, fpr0);
+          }
+          jit_fpu_roundr_ld_l_fppop(JIT_R1, fpr0);
+          if (!unsafe_fl) {
+            /* to check whether it fits in a fixnum, we
+               need to convert back and check whether it
+               is the same */
+            if (unboxed)
+              jit_fpu_movr_ld_fppush(fpr1+1, fpr1); /* for slow path */
+            jit_fpu_extr_l_ld_fppush(fpr0, JIT_R1);
+            __START_TINY_JUMPS__(1);
+            refs = jit_fpu_bantieqr_ld_fppop(jit_forward(), fpr0, fpr1);
+            __END_TINY_JUMPS__(1);
+            /* result still may not fit in a fixnum */
+            jit_lshi_l(JIT_R2, JIT_R1, 1);
+            jit_rshi_l(JIT_R2, JIT_R2, 1);
+            __START_TINY_JUMPS__(1);
+            refs2 = jit_bner_l(jit_forward(), JIT_R1, JIT_R2);
+            __END_TINY_JUMPS__(1);
+          }
+        } else
+#endif
+          {
+          if (!unsafe_fl) {
+            jit_movr_d_fppush(fpr1, fpr0);
+          }
+          jit_roundr_d_l_fppop(JIT_R1, fpr0);
+          if (!unsafe_fl) {
+            /* to check whether it fits in a fixnum, we
+               need to convert back and check whether it
+               is the same */
+            if (unboxed)
+              jit_movr_d_fppush(fpr1+1, fpr1); /* for slow path */
+            jit_extr_l_d_fppush(fpr0, JIT_R1);
+            __START_TINY_JUMPS__(1);
+            refs = jit_bantieqr_d_fppop(jit_forward(), fpr0, fpr1);
+            __END_TINY_JUMPS__(1);
+            /* result still may not fit in a fixnum */
+            jit_lshi_l(JIT_R2, JIT_R1, 1);
+            jit_rshi_l(JIT_R2, JIT_R2, 1);
+            __START_TINY_JUMPS__(1);
+            refs2 = jit_bner_l(jit_forward(), JIT_R1, JIT_R2);
+            __END_TINY_JUMPS__(1);
+#ifndef DIRECT_FPR_ACCESS
+            if (unboxed)
+              jit_roundr_d_l_fppop(JIT_R1, fpr2); /* slow path won't be needed */
 #endif
+          }
         }
         jit_fixnum_l(dest, JIT_R1);
         no_alloc = 1;
         break;
       case ARITH_SQRT:
-        jit_fpu_sqrt_ld_fppop(fpr0, fpr0);
+#ifdef MZ_LONG_DOUBLE
+        if (call_for_extfl)
+          jit_fpu_sqrt_ld_fppop(fpr0, fpr0);
+        else
+#endif
+          jit_sqrt_d_fppop(fpr0, fpr0);
         break;
 #ifdef CAN_INLINE_ALLOC
 # ifdef JIT_USE_FP_OPS
       case ARITH_FLUNOP: /* flfloor, flsin, etc. */
         {
           call_fp_proc f;
-
-          if (IS_NAMED_PRIM(rator, "extflsin"))
-            f = call_long_double_sin;
-          else if (IS_NAMED_PRIM(rator, "extflcos"))
-            f = call_long_double_cos;
-          else if (IS_NAMED_PRIM(rator, "extfltan"))
-            f = call_long_double_tan;
-          else if (IS_NAMED_PRIM(rator, "extflasin"))
-            f = call_long_double_asin;
-          else if (IS_NAMED_PRIM(rator, "extflacos"))
-            f = call_long_double_acos;
-          else if (IS_NAMED_PRIM(rator, "extflatan"))
-            f = call_long_double_atan;
-          else if (IS_NAMED_PRIM(rator, "extflexp"))
-            f = call_long_double_exp;
-          else if (IS_NAMED_PRIM(rator, "extfllog"))
-            f = call_long_double_log;
-          else if (IS_NAMED_PRIM(rator, "extflfloor"))
-            f = call_long_double_floor;
-          else if (IS_NAMED_PRIM(rator, "extflceiling"))
-            f = call_long_double_ceiling;
-          else if (IS_NAMED_PRIM(rator, "extfltruncate"))
-            f = call_long_double_truncate;
-          else if (IS_NAMED_PRIM(rator, "extflround"))
-            f = call_long_double_round;
-          else {
-            scheme_signal_error("internal error: unknown extflonum function");
-            f = NULL;
+#ifdef MZ_LONG_DOUBLE
+          if (call_for_extfl) {
+            if (IS_NAMED_PRIM(rator, "extflsin"))
+              f = call_long_double_sin;
+            else if (IS_NAMED_PRIM(rator, "extflcos"))
+              f = call_long_double_cos;
+            else if (IS_NAMED_PRIM(rator, "extfltan"))
+              f = call_long_double_tan;
+            else if (IS_NAMED_PRIM(rator, "extflasin"))
+              f = call_long_double_asin;
+            else if (IS_NAMED_PRIM(rator, "extflacos"))
+              f = call_long_double_acos;
+            else if (IS_NAMED_PRIM(rator, "extflatan"))
+              f = call_long_double_atan;
+            else if (IS_NAMED_PRIM(rator, "extflexp"))
+              f = call_long_double_exp;
+            else if (IS_NAMED_PRIM(rator, "extfllog"))
+              f = call_long_double_log;
+            else if (IS_NAMED_PRIM(rator, "extflfloor"))
+              f = call_long_double_floor;
+            else if (IS_NAMED_PRIM(rator, "extflceiling"))
+              f = call_long_double_ceiling;
+            else if (IS_NAMED_PRIM(rator, "extfltruncate"))
+              f = call_long_double_truncate;
+            else if (IS_NAMED_PRIM(rator, "extflround"))
+              f = call_long_double_round;
+            else {
+              scheme_signal_error("internal error: unknown extflonum function");
+              f = NULL;
+            }
+            (void)mz_fpu_tl_sti_ld_fppop(tl_scheme_jit_save_extfp, JIT_FPU_FPR0, JIT_R2);
+            mz_prepare(0);
+            (void)mz_finish(f);
+            (void)mz_fpu_tl_ldi_ld_fppush(JIT_FPU_FPR0, tl_scheme_jit_save_extfp, JIT_R2);
+          } else
+#endif           
+            {
+            if (IS_NAMED_PRIM(rator, "flsin"))
+              f = call_sin;
+            else if (IS_NAMED_PRIM(rator, "flcos"))
+              f = call_cos;
+            else if (IS_NAMED_PRIM(rator, "fltan"))
+              f = call_tan;
+            else if (IS_NAMED_PRIM(rator, "flasin"))
+              f = call_asin;
+            else if (IS_NAMED_PRIM(rator, "flacos"))
+              f = call_acos;
+            else if (IS_NAMED_PRIM(rator, "flatan"))
+              f = call_atan;
+            else if (IS_NAMED_PRIM(rator, "flexp"))
+              f = call_exp;
+            else if (IS_NAMED_PRIM(rator, "fllog"))
+              f = call_log;
+            else if (IS_NAMED_PRIM(rator, "flfloor"))
+              f = call_floor;
+            else if (IS_NAMED_PRIM(rator, "flceiling"))
+              f = call_ceiling;
+            else if (IS_NAMED_PRIM(rator, "fltruncate"))
+              f = call_truncate;
+            else if (IS_NAMED_PRIM(rator, "flround"))
+              f = call_round;
+            else {
+              scheme_signal_error("internal error: unknown flonum function");
+              f = NULL;
+            }
+            (void)mz_tl_sti_d_fppop(tl_scheme_jit_save_fp, JIT_FPR0, JIT_R2);
+            mz_prepare(0);
+            (void)mz_finish(f);
+            (void)mz_tl_ldi_d_fppush(JIT_FPR0, tl_scheme_jit_save_fp, JIT_R2);
           }
-          (void)mz_fpu_tl_sti_ld_fppop(tl_scheme_jit_save_extfp, JIT_FPU_FPR0, JIT_R2);
-          mz_prepare(0);
-          (void)mz_finish(f);
-          (void)mz_fpu_tl_ldi_ld_fppush(JIT_FPU_FPR0, tl_scheme_jit_save_extfp, JIT_R2);
         }
         break;
       case ARITH_EXPT: /* flexpt */
         {
-          if (!reversed) {
-            (void)mz_fpu_tl_sti_ld_fppop(tl_scheme_jit_save_extfp2, JIT_FPU_FPR0, JIT_R2);
-            (void)mz_fpu_tl_sti_ld_fppop(tl_scheme_jit_save_extfp, JIT_FPU_FPR1, JIT_R2);
-          } else {
-            (void)mz_fpu_tl_sti_ld_fppop(tl_scheme_jit_save_extfp, JIT_FPU_FPR0, JIT_R2);
-            (void)mz_fpu_tl_sti_ld_fppop(tl_scheme_jit_save_extfp2, JIT_FPU_FPR1, JIT_R2);
+#ifdef MZ_LONG_DOUBLE
+          if (call_for_extfl) {
+            if (!reversed) {
+              (void)mz_fpu_tl_sti_ld_fppop(tl_scheme_jit_save_extfp2, JIT_FPU_FPR0, JIT_R2);
+              (void)mz_fpu_tl_sti_ld_fppop(tl_scheme_jit_save_extfp, JIT_FPU_FPR1, JIT_R2);
+            } else {
+              (void)mz_fpu_tl_sti_ld_fppop(tl_scheme_jit_save_extfp, JIT_FPU_FPR0, JIT_R2);
+              (void)mz_fpu_tl_sti_ld_fppop(tl_scheme_jit_save_extfp2, JIT_FPU_FPR1, JIT_R2);
+            }
+            mz_prepare(0);
+            (void)mz_finish(call_long_double_expt);
+            (void)mz_fpu_tl_ldi_ld_fppush(JIT_FPU_FPR0, tl_scheme_jit_save_extfp, JIT_R2);
+          } else
+#endif
+            {
+            if (!reversed) {
+              (void)mz_tl_sti_d_fppop(tl_scheme_jit_save_fp2, JIT_FPR0, JIT_R2);
+              (void)mz_tl_sti_d_fppop(tl_scheme_jit_save_fp, JIT_FPR1, JIT_R2);
+            } else {
+              (void)mz_tl_sti_d_fppop(tl_scheme_jit_save_fp, JIT_FPR0, JIT_R2);
+              (void)mz_tl_sti_d_fppop(tl_scheme_jit_save_fp2, JIT_FPR1, JIT_R2);
+            }
+            mz_prepare(0);
+            (void)mz_finish(call_expt);
+            (void)mz_tl_ldi_d_fppush(JIT_FPR0, tl_scheme_jit_save_fp, JIT_R2);          
           }
-          mz_prepare(0);
-          (void)mz_finish(call_long_double_expt);
-          (void)mz_fpu_tl_ldi_ld_fppush(JIT_FPU_FPR0, tl_scheme_jit_save_extfp, JIT_R2);          
         }
         break;
 # endif
@@ -814,7 +1002,12 @@ static int generate_long_double_arith(mz_jit_state *jitter, Scheme_Object *rator
 
       if (!no_alloc) {
         mz_rs_sync(); /* needed if arguments were unboxed */
-        scheme_generate_alloc_long_double(jitter, 0, dest);
+#ifdef MZ_LONG_DOUBLE
+        if (call_for_extfl)
+          scheme_generate_alloc_long_double(jitter, 0, dest);
+        else
+#endif
+          scheme_generate_alloc_double(jitter, 0, dest);
         CHECK_LIMIT();
 #if defined(MZ_USE_JIT_I386)
         if (need_post_pop)
@@ -839,1458 +1032,157 @@ static int generate_long_double_arith(mz_jit_state *jitter, Scheme_Object *rator
         CHECK_LIMIT();
       }
       R0_FP_ADJUST(_jitl.r0_can_be_tmp++);
-      switch (cmp) {
-      case CMP_LT:
-        refd = jit_fpu_bantigtr_ld_fppop(jit_forward(), fpr0, fpr1);
-        break;
-      case CMP_LEQ:
-        refd = jit_fpu_bantiger_ld_fppop(jit_forward(), fpr0, fpr1);
-        break;
-      case CMP_EQUAL:
-        refd = jit_fpu_bantieqr_ld_fppop(jit_forward(), fpr0, fpr1);
-        break;
-      case CMP_GEQ:
-        refd = jit_fpu_bantiler_ld_fppop(jit_forward(), fpr0, fpr1);
-        break;
-      case CMP_GT:
-        refd = jit_fpu_bantiltr_ld_fppop(jit_forward(), fpr0, fpr1);
-        break;
-      default:
-        refd = NULL;
-        break;
-      }
-      R0_FP_ADJUST(_jitl.r0_can_be_tmp--);
-      __END_SHORT_JUMPS__(branch_short);
-      *_refd = refd;
-    }
-  }
-
-  if (!unsafe_extfl) {
-    /* Jump to return result or true branch: */
-    __START_SHORT_JUMPS__(branch_short);
-    refdt = jit_jmpi(jit_forward());
-    *_refdt = refdt;
-    __END_SHORT_JUMPS__(branch_short);
-  }
-
-  if (!unsafe_extfl) {
-    /* No, they're not both doubles, or slow path is needed
-       for some other reason. */
-    __START_TINY_JUMPS__(1);
-    if (!unboxed) {
-      if (two_args) {
-        mz_patch_branch(ref8);
-        mz_patch_branch(ref10);
-      }
-      mz_patch_branch(ref9);
-    }
-    if (refs)
-      mz_patch_branch(refs);
-    if (refs2)
-      mz_patch_branch(refs2);
-    __END_TINY_JUMPS__(1);
-  }
-#endif
-  
-  return 1;
-}
-#endif
-
-static int generate_double_arith(mz_jit_state *jitter, Scheme_Object *rator,
-                                 int arith, int cmp, int reversed, int two_args, int second_const,
-                                 jit_insn **_refd, jit_insn **_refdt, Branch_Info *for_branch,
-                                 int branch_short, int unsafe_fl, int unboxed, int unboxed_result,
-                                 int dest)
-/* Unless unboxed, first arg is in JIT_R1, second in JIT_R0.
-   If unboxed in push/pop mode, first arg is pushed before second.
-   If unboxed in direct mode, first arg is in JIT_FPR0+depth
-    and second is in JIT_FPR1+depth (which is backward). 
-   Unboxed implies unsafe unless arith == ARITH_INEX_EX. */
-{
-#if defined(INLINE_FP_OPS) || defined(INLINE_FP_COMP)
-  GC_CAN_IGNORE jit_insn *ref8, *ref9, *ref10, *refd, *refdt, *refs = NULL, *refs2 = NULL;
-  int no_alloc = unboxed_result, need_post_pop = 0;
-
-  if (!unsafe_fl && !unboxed) {
-    /* Maybe they're doubles */
-    __START_TINY_JUMPS__(1);
-    if (two_args) {
-      jit_orr_ul(JIT_R2, JIT_R0, JIT_R1);
-      ref8 = jit_bmsi_ul(jit_forward(), JIT_R2, 0x1);
-    } else
-      ref8 = NULL;
-    jit_ldxi_s(JIT_R2, JIT_R0, &((Scheme_Object *)0x0)->type);
-    ref9 = jit_bnei_i(jit_forward(), JIT_R2, scheme_double_type);
-    if (two_args) {
-      jit_ldxi_s(JIT_R2, JIT_R1, &((Scheme_Object *)0x0)->type);
-      ref10 = jit_bnei_i(jit_forward(), JIT_R2, scheme_double_type);
-    } else
-      ref10 = NULL;
-    CHECK_LIMIT();
-    __END_TINY_JUMPS__(1);
-  } else {
-    ref8 = ref9 = ref10 = NULL;
-  }
-
-  if (!two_args && !second_const && ((arith == ARITH_MUL) || ((arith == ARITH_DIV) && reversed))) {
-    /* Special case: multiplication by exact 0 */
-    (void)jit_movi_p(dest, scheme_make_integer(0));
-  } else {
-    /* Yes, they're doubles. First arg is in JIT_R1, second is in JIT_R0. 
-       Put the first arg in fpr0 and second (if any) into fpr1. To work
-       right with stacks, that means pushing the second argument first. */
-    int fpr1, fpr0;
-
-    fpr0 = JIT_FPR_0(jitter->unbox_depth);
-    fpr1 = JIT_FPR_1(1+jitter->unbox_depth);
-
-    if (two_args) {
-      if (!unboxed)
-        jit_ldxi_d_fppush(fpr1, JIT_R1, &((Scheme_Double *)0x0)->double_val);
-    } else if ((arith == ARITH_SUB) && !second_const && reversed) {
-      reversed = 0;
-    } else if (arith == ARITH_ABS) {
-      /* abs needs no extra number */
-    } else if (arith == ARITH_SQRT) {
-      /* sqrt needs no extra number */
-    } else if (arith == ARITH_FLUNOP) {
-      /* flround, flsin, etc. needs no extra number */
-    } else if (arith == ARITH_EX_INEX) {
-      /* exact->inexact needs no extra number */
-    } else if (arith == ARITH_INEX_EX) {
-      /* inexact->exact needs no extra number */
-    } else {
-      double d = second_const;
-      mz_movi_d_fppush(fpr1, d, JIT_R2);
-      reversed = !reversed;
-      cmp = -cmp;
-    }
-
-    if (!unboxed) {
-      if (arith != ARITH_EX_INEX) {
-        jit_ldxi_d_fppush(fpr0, JIT_R0, &((Scheme_Double *)0x0)->double_val);
-      }
-    }
-
-#ifdef DIRECT_FPR_ACCESS
-    if (unboxed) {
-      /* arguments are backward */
-      reversed = !reversed;
-      cmp = -cmp;
-    }
-#endif
-
-    if (arith) {
-      switch (arith) {
-      case ARITH_ADD:
-        jit_addr_d_fppop(fpr0, fpr0, fpr1);
-        break;
-      case ARITH_MUL:
-        jit_mulr_d_fppop(fpr0, fpr0, fpr1);
-        break;
-      case ARITH_DIV:
-        if (!reversed)
-          jit_divrr_d_fppop(fpr0, fpr0, fpr1);
-        else
-          jit_divr_d_fppop(fpr0, fpr0, fpr1);
-        break;
-      case ARITH_SUB:
-        {
-          if (!two_args && !second_const && !reversed) {
-            /* Need a special case to make sure that (- 0.0) => -0.0 */
-            jit_negr_d_fppop(fpr0, fpr0);
-          } else if (reversed)
-            jit_subr_d_fppop(fpr0, fpr0, fpr1);
-          else
-            jit_subrr_d_fppop(fpr0, fpr0, fpr1);
-        }
-        break;
-      case ARITH_MIN:
-      case ARITH_MAX:
-        {
-          GC_CAN_IGNORE jit_insn *refc, *refn;
-          __START_TINY_JUMPS__(1);
-	  /* If R0 is nan, then copy to R1, ensuring nan result */
-	  refn = jit_beqr_d(jit_forward(), fpr0, fpr0);
-          if (unboxed)
-            jit_movr_d_rel(fpr1, fpr0);
-          else
-            jit_movr_p(JIT_R1, JIT_R0);
-	  mz_patch_branch(refn);
-          if (arith == ARITH_MIN) {
-            if (unboxed) {
-              refc = jit_bltr_d(jit_forward(), fpr0, fpr1);
-            } else {
-              refc = jit_bltr_d_fppop(jit_forward(), fpr0, fpr1);
-            }
-          } else {
-            if (unboxed) {
-              refc = jit_bger_d(jit_forward(), fpr0, fpr1);
-            } else {
-              refc = jit_bger_d_fppop(jit_forward(), fpr0, fpr1);
-            }
-          }
-          if (unboxed) {
-            jit_movr_d_rel(fpr0, fpr1);
-            need_post_pop = 1;
-          } else
-            jit_movr_p(JIT_R0, JIT_R1);
-          mz_patch_branch(refc);
-          __END_TINY_JUMPS__(1);
-          if (!unboxed) {
-            /* we've already set JIT_R0 */
-            jit_movr_p(dest, JIT_R0);
-            no_alloc = 1;
-          }
-        }
-        break;
-      case ARITH_ABS:
-        jit_abs_d_fppop(fpr0, fpr0);
-        break;
-      case ARITH_EX_INEX: /* exact->inexact */
-        /* no work to do, because argument is already inexact;
-           no need to allocate, because argument is never unboxed,
-           and it therefore already resides in R0 */
-        jit_movr_p(dest, JIT_R0);
-        no_alloc = 1;
-        break;
-      case ARITH_INEX_EX: /* inexact->exact */
-        if (!unsafe_fl) {
-          jit_movr_d_fppush(fpr1, fpr0);
-        }
-        jit_roundr_d_l_fppop(JIT_R1, fpr0);
-        if (!unsafe_fl) {
-          /* to check whether it fits in a fixnum, we
-             need to convert back and check whether it
-             is the same */
-          if (unboxed)
-            jit_movr_d_fppush(fpr1+1, fpr1); /* for slow path */
-          jit_extr_l_d_fppush(fpr0, JIT_R1);
-          __START_TINY_JUMPS__(1);
-          refs = jit_bantieqr_d_fppop(jit_forward(), fpr0, fpr1);
-          __END_TINY_JUMPS__(1);
-          /* result still may not fit in a fixnum */
-          jit_lshi_l(JIT_R2, JIT_R1, 1);
-          jit_rshi_l(JIT_R2, JIT_R2, 1);
-          __START_TINY_JUMPS__(1);
-          refs2 = jit_bner_l(jit_forward(), JIT_R1, JIT_R2);
-          __END_TINY_JUMPS__(1);
-#ifndef DIRECT_FPR_ACCESS
-          if (unboxed)
-            jit_roundr_d_l_fppop(JIT_R1, fpr2); /* slow path won't be needed */
-#endif
-        }
-        jit_fixnum_l(dest, JIT_R1);
-        no_alloc = 1;
-        break;
-      case ARITH_SQRT:
-        jit_sqrt_d_fppop(fpr0, fpr0);
-        break;
-#ifdef CAN_INLINE_ALLOC
-# ifdef JIT_USE_FP_OPS
-      case ARITH_FLUNOP: /* flfloor, flsin, etc. */
-        {
-          call_fp_proc f;
-
-          if (IS_NAMED_PRIM(rator, "flsin"))
-            f = call_sin;
-          else if (IS_NAMED_PRIM(rator, "flcos"))
-            f = call_cos;
-          else if (IS_NAMED_PRIM(rator, "fltan"))
-            f = call_tan;
-          else if (IS_NAMED_PRIM(rator, "flasin"))
-            f = call_asin;
-          else if (IS_NAMED_PRIM(rator, "flacos"))
-            f = call_acos;
-          else if (IS_NAMED_PRIM(rator, "flatan"))
-            f = call_atan;
-          else if (IS_NAMED_PRIM(rator, "flexp"))
-            f = call_exp;
-          else if (IS_NAMED_PRIM(rator, "fllog"))
-            f = call_log;
-          else if (IS_NAMED_PRIM(rator, "flfloor"))
-            f = call_floor;
-          else if (IS_NAMED_PRIM(rator, "flceiling"))
-            f = call_ceiling;
-          else if (IS_NAMED_PRIM(rator, "fltruncate"))
-            f = call_truncate;
-          else if (IS_NAMED_PRIM(rator, "flround"))
-            f = call_round;
-          else {
-            scheme_signal_error("internal error: unknown flonum function");
-            f = NULL;
-          }
-          (void)mz_tl_sti_d_fppop(tl_scheme_jit_save_fp, JIT_FPR0, JIT_R2);
-          mz_prepare(0);
-          (void)mz_finish(f);
-          (void)mz_tl_ldi_d_fppush(JIT_FPR0, tl_scheme_jit_save_fp, JIT_R2);
-        }
-        break;
-      case ARITH_EXPT: /* flexpt */
-        {
-          if (!reversed) {
-            (void)mz_tl_sti_d_fppop(tl_scheme_jit_save_fp2, JIT_FPR0, JIT_R2);
-            (void)mz_tl_sti_d_fppop(tl_scheme_jit_save_fp, JIT_FPR1, JIT_R2);
-          } else {
-            (void)mz_tl_sti_d_fppop(tl_scheme_jit_save_fp, JIT_FPR0, JIT_R2);
-            (void)mz_tl_sti_d_fppop(tl_scheme_jit_save_fp2, JIT_FPR1, JIT_R2);
-          }
-          mz_prepare(0);
-          (void)mz_finish(call_expt);
-          (void)mz_tl_ldi_d_fppush(JIT_FPR0, tl_scheme_jit_save_fp, JIT_R2);          
-        }
-        break;
-# endif
-#endif
-      default:
-        break;
-      }
-      CHECK_LIMIT();
-
-      if (!no_alloc) {
-        mz_rs_sync(); /* needed if arguments were unboxed */
-        scheme_generate_alloc_double(jitter, 0, dest);
-        CHECK_LIMIT();
-#if defined(MZ_USE_JIT_I386)
-        if (need_post_pop)
-          FSTPr(0);
-#endif
-      } else if (unboxed_result) {
-        jitter->unbox_depth++;
-#if defined(MZ_USE_JIT_I386)
-        if (need_post_pop) {
-          FXCHr(1);
-          FSTPr(0);
-        }
-#endif
-      }
-    } else {
-      /* The "anti" variants below invert the branch. Unlike the "un" 
-         variants, the "anti" variants invert the comparison result
-         after the layer where +nan.0 always generates false. */
-      __START_SHORT_JUMPS__(branch_short);
-      if (for_branch) {
-        scheme_prepare_branch_jump(jitter, for_branch);
-        CHECK_LIMIT();
-      }
-      R0_FP_ADJUST(_jitl.r0_can_be_tmp++);
-      switch (cmp) {
-      case CMP_LT:
-        refd = jit_bantigtr_d_fppop(jit_forward(), fpr0, fpr1);
-        break;
-      case CMP_LEQ:
-        refd = jit_bantiger_d_fppop(jit_forward(), fpr0, fpr1);
-        break;
-      case CMP_EQUAL:
-        refd = jit_bantieqr_d_fppop(jit_forward(), fpr0, fpr1);
-        break;
-      case CMP_GEQ:
-        refd = jit_bantiler_d_fppop(jit_forward(), fpr0, fpr1);
-        break;
-      case CMP_GT:
-        refd = jit_bantiltr_d_fppop(jit_forward(), fpr0, fpr1);
-        break;
-      default:
-        refd = NULL;
-        break;
-      }
-      R0_FP_ADJUST(_jitl.r0_can_be_tmp--);
-      __END_SHORT_JUMPS__(branch_short);
-      *_refd = refd;
-    }
-  }
-
-  if (!unsafe_fl) {
-    /* Jump to return result or true branch: */
-    __START_SHORT_JUMPS__(branch_short);
-    refdt = jit_jmpi(jit_forward());
-    *_refdt = refdt;
-    __END_SHORT_JUMPS__(branch_short);
-  }
-
-  if (!unsafe_fl) {
-    /* No, they're not both doubles, or slow path is needed
-       for some other reason. */
-    __START_TINY_JUMPS__(1);
-    if (!unboxed) {
-      if (two_args) {
-        mz_patch_branch(ref8);
-        mz_patch_branch(ref10);
-      }
-      mz_patch_branch(ref9);
-    }
-    if (refs)
-      mz_patch_branch(refs);
-    if (refs2)
-      mz_patch_branch(refs2);
-    __END_TINY_JUMPS__(1);
-  }
-#endif
-  
-  return 1;
-}
-
-static int check_flonum_result(mz_jit_state *jitter, int reg, void *fail_code, Scheme_Object *rator)
-/* Doesn't use R0 or R1, except for `reg' */
-{
-  /* Check for flonum result */
-  GC_CAN_IGNORE jit_insn *ref, *reffail;
-
-  mz_rs_sync();
-
-  __START_TINY_JUMPS__(1);
-  ref = jit_bmci_l(jit_forward(), reg, 0x1);
-  __END_TINY_JUMPS__(1);
-
-  reffail = _jit.x.pc;
-  (void)jit_movi_p(JIT_V1, ((Scheme_Primitive_Proc *)rator)->prim_val);
-  (void)jit_calli(fail_code);
-
-  __START_TINY_JUMPS__(1);
-  mz_patch_branch(ref);
-  __END_TINY_JUMPS__(1);
-
-  jit_ldxi_s(JIT_R2, JIT_R0, &((Scheme_Object *)0x0)->type);
-  __START_SHORT_JUMPS__(1);
-  (void)jit_bnei_i(reffail, JIT_R2, scheme_double_type);
-  __END_SHORT_JUMPS__(1);
-  CHECK_LIMIT();
-
-  scheme_generate_unboxing(jitter, reg);
-
-  return 1;
-}
-
-#ifdef MZ_LONG_DOUBLE
-static int check_extflonum_result(mz_jit_state *jitter, int reg, void *fail_code, Scheme_Object *rator)
-/* Doesn't use R0 or R1, except for `reg' */
-{
-  /* Check for flonum result */
-  GC_CAN_IGNORE jit_insn *ref, *reffail;
-
-  mz_rs_sync();
-
-  __START_TINY_JUMPS__(1);
-  ref = jit_bmci_l(jit_forward(), reg, 0x1);
-  __END_TINY_JUMPS__(1);
-
-  reffail = _jit.x.pc;
-  (void)jit_movi_p(JIT_V1, ((Scheme_Primitive_Proc *)rator)->prim_val);
-  (void)jit_calli(fail_code);
-
-  __START_TINY_JUMPS__(1);
-  mz_patch_branch(ref);
-  __END_TINY_JUMPS__(1);
-
-  jit_ldxi_s(JIT_R2, JIT_R0, &((Scheme_Object *)0x0)->type);
-  __START_SHORT_JUMPS__(1);
-  (void)jit_bnei_i(reffail, JIT_R2, scheme_double_type);
-  __END_SHORT_JUMPS__(1);
-  CHECK_LIMIT();
-
-  scheme_generate_unboxing(jitter, reg);
-
-  return 1;
-}
-#endif
-
-static void generate_modulo_setup(mz_jit_state *jitter, int branch_short, int a1, int a2)
-/* r1 has two flags: bit 0 means two args have different sign; bit 1 means second arg is negative */
-{
-  GC_CAN_IGNORE jit_insn *refx;
-
-  jit_movi_l(JIT_R1, 0x0);
-  __START_INNER_TINY__(branch_short);
-  refx = jit_bgei_l(jit_forward(), a1, 0);
-  jit_negr_l(a1, a1);
-  jit_movi_l(JIT_R1, 0x1);
-  mz_patch_branch(refx);
-  refx = jit_bgei_l(jit_forward(), a2, 0);
-  jit_xori_l(JIT_R1, JIT_R1, 0x3);
-  jit_negr_l(a2, a2);
-  mz_patch_branch(refx);
-  __END_INNER_TINY__(branch_short);
-}
-
-#ifdef MZ_LONG_DOUBLE
-int scheme_generate_extflonum_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Object *rand, Scheme_Object *rand2, 
-                                    int orig_args, int arith, int cmp, int v, 
-                                    Branch_Info *for_branch, int branch_short,
-                                    int unsafe_fx, int unsafe_extfl, GC_CAN_IGNORE jit_insn *overflow_refslow,
-                                    int dest)
-/* needs de-sync */
-/* Operation codes are defined in jit.h.
-   Either arith is non-zero or it's a cmp; the value of each determines the operation:
-        arith = 1 -> + or add1 (if !rand2)
-        arith = -1 -> - or sub1
-        arith = 2 -> *
-        arith = -2 -> /
-        arith = -3 -> quotient
-        arith = -4 -> remainder
-        arith = -5 -> modulo
-        arith = 3 -> bitwise-and
-        arith = 4 -> bitwise-ior
-        arith = 5 -> bitwise-xor
-        arith = 6 -> arithmetic-shift, fxlshift
-        arith = -6 -> fxrshift
-        arith = 7 -> bitwise-not
-        arith = 9 -> min
-        arith = 10 -> max
-        arith = 11 -> abs
-        arith = 12 -> exact->inexact
-        arith = 13 -> sqrt
-        arith = 14 -> unary floating-point op (consult `rator')
-        arith = 15 -> inexact->exact
-        cmp = 0 -> = or zero?
-        cmp = +/-1 -> >=/<=
-        cmp = +/-2 -> >/< or positive/negative?
-        cmp = 3 -> bitwise-bit-test?
-        cmp = +/-4 -> even?/odd?
-   If rand is NULL, then we're generating part of the fast path for an
-   nary arithmatic over a binary operator; the first argument is
-   already in R0 (fixnum or min/max) or a floating-point register
-   (flonum) and the second argument is in R1 (fixnum or min/max) or a
-   floating-point register (flonum).
-   For unsafe_fx or unsafe_extfl, -1 means safe but specific to the type.
-*/
-{
-  GC_CAN_IGNORE jit_insn *ref, *ref2, *ref3, *ref4, *refd = NULL, *refdt = NULL;
-  GC_CAN_IGNORE jit_insn *refslow;
-  int reversed = 0;
-  int has_fixnum_fast = 1, has_extflonum_fast = 1;
-  int inlined_extflonum1, inlined_extflonum2;
-
-  LOG_IT(("inlined %s\n", rator ? ((Scheme_Primitive_Proc *)rator)->name : "???"));
-
-  if (unsafe_fx < 0) {
-    unsafe_fx = 0;
-    has_extflonum_fast = 0;
-  }
-
-  if (unsafe_extfl) {
-    if (!rand) {
-      inlined_extflonum1 = inlined_extflonum2 = 1;
-    } else {
-      if (scheme_can_unbox_inline(rand, 5, JIT_FPU_FPR_NUM-2, unsafe_extfl > 0))
-        inlined_extflonum1 = 1;
-      else
-        inlined_extflonum1 = 0;
-      if (!rand2 || scheme_can_unbox_inline(rand2, 5, JIT_FPU_FPR_NUM-3, unsafe_extfl > 0))
-        inlined_extflonum2 = 1;
-      else
-        inlined_extflonum2 = 0;
-    }
-  } else
-    inlined_extflonum1 = inlined_extflonum2 = 0;
-
-  if (unsafe_extfl
-#ifndef USE_EXTFLONUM_UNBOXING
-      && inlined_extflonum1 && inlined_extflonum2
-#endif
-      ) {
-    /* Unboxed (and maybe unsafe) floating-point ops. */
-    int args_unboxed = (((arith != ARITH_MIN) && (arith != ARITH_MAX)) || rand);
-    int extflonum_depth, extfl_reversed = 0, can_direct1, can_direct2;
-
-    if (inlined_extflonum1 && inlined_extflonum2 && (arith != ARITH_INEX_EX))
-      /* safe can be implemented as unsafe */
-      unsafe_extfl = 1;
-    
-    if (!args_unboxed && rand)
-      scheme_signal_error("internal error: invalid mode");
-
-    if (inlined_extflonum1 && !inlined_extflonum2 && can_reorder_unboxing(rand, rand2)) {
-      GC_CAN_IGNORE Scheme_Object *tmp;
-      reversed = !reversed;
-      cmp = -cmp;
-      extfl_reversed = 1;
-      tmp = rand;
-      rand = rand2;
-      rand2 = tmp;
-      inlined_extflonum1 = 0;
-      inlined_extflonum2 = 1;
-    }
-
-    if (inlined_extflonum1)
-      can_direct1 = 2;
-    else
-      can_direct1 = scheme_can_unbox_directly(rand);
-    if (inlined_extflonum2)
-      can_direct2 = 2;
-    else 
-      can_direct2 = scheme_can_unbox_directly(rand2);
-
-    if (args_unboxed) {
-      jitter->unbox++;
-      jitter->unbox_extflonum++;
-    }
-    if (!rand) {
-      CHECK_LIMIT();
-      if (args_unboxed)
-        extflonum_depth = 2;
-      else
-        extflonum_depth = 0;
-    } else if (!rand2) {
-      mz_runstack_skipped(jitter, 1);
-      scheme_generate_unboxed(rand, jitter, can_direct1, (unsafe_extfl > 0));
-      CHECK_LIMIT();
-      mz_runstack_unskipped(jitter, 1);
-      if (!can_direct1 && (unsafe_extfl <= 0)) {
-        check_extflonum_result(jitter, JIT_R0, sjc.extfl1_fail_code, rator);
-        CHECK_LIMIT();
-      }
-      extflonum_depth = 1;
-    } else {
-#ifdef USE_EXTFLONUM_UNBOXING
-      int extflostack = 0, extflopos = 0;
-#endif
-      mz_runstack_skipped(jitter, 2);
-      scheme_generate_unboxed(rand, jitter, can_direct1, (unsafe_extfl > 0));
-      CHECK_LIMIT();
-      if (!(inlined_extflonum1 && inlined_extflonum2)) {
-        if (!can_direct1 && (unsafe_extfl <= 0)) {
-          mz_pushr_p(JIT_R0);
-        } else if (!inlined_extflonum2) {
-#ifdef USE_EXTFLONUM_UNBOXING
-          extflostack = scheme_mz_extflostack_save(jitter, &extflopos);
-          --jitter->unbox_depth;
-          scheme_generate_extflonum_local_unboxing(jitter, 0);
-          CHECK_LIMIT();
-#endif        
-        }
-      }
-      scheme_generate_unboxed(rand2, jitter, can_direct2, (unsafe_extfl > 0));
-      CHECK_LIMIT();
-      if (!(inlined_extflonum1 && inlined_extflonum2)) {
-        if ((can_direct1 || (unsafe_extfl > 0)) && !inlined_extflonum2) {
-#ifdef USE_EXTFLONUM_UNBOXING
-          int fpr0;
-          fpr0 = JIT_FPU_FPR_0(jitter->unbox_depth);
-          mz_fpu_ld_ld_fppush(fpr0, jitter->extflostack_offset);
-          scheme_mz_extflostack_restore(jitter, extflostack, extflopos, 1, 1);
-          CHECK_LIMIT();
-          jitter->unbox_depth++;
-#endif
-        }
-        if (!can_direct2 && (unsafe_extfl <= 0)) {
-          jit_movr_p(JIT_R1, JIT_R0);
-          if (!can_direct1) {
-            mz_popr_p(JIT_R0);
-            check_extflonum_result(jitter, JIT_R0, sjc.extfl2rr_fail_code[extfl_reversed], rator);
-            CHECK_LIMIT();
-          }
-          check_extflonum_result(jitter, JIT_R1, sjc.extfl2fr_fail_code[extfl_reversed], rator);
-          CHECK_LIMIT();
-        } else {
-          if (!can_direct1 && (unsafe_extfl <= 0)) {
-            mz_popr_p(JIT_R0);
-            check_extflonum_result(jitter, JIT_R0, sjc.extfl2rf_fail_code[extfl_reversed], rator);
-            CHECK_LIMIT();
-          }
-          if (!(can_direct1 || (unsafe_extfl > 0)) || !inlined_extflonum2) {
-            cmp = -cmp;
-            reversed = !reversed;
-          }
-        }
-      }
-      mz_runstack_unskipped(jitter, 2);
-      extflonum_depth = 2;
-    }
-    if (args_unboxed) {
-      --jitter->unbox;
-      --jitter->unbox_extflonum;
-    }
-    jitter->unbox_depth -= extflonum_depth;
-    if (!jitter->unbox && jitter->unbox_depth && rand)
-      scheme_signal_error("internal error: broken unbox depth");
-    if (for_branch
-        || (arith == ARITH_INEX_EX)) /* has slow path */
-      mz_rs_sync(); /* needed if arguments were unboxed */
-
-    generate_long_double_arith(jitter, rator, arith, cmp, reversed, !!rand2, 0,
-                               &refd, &refdt, for_branch, branch_short, 
-                               (arith == ARITH_INEX_EX) ? (unsafe_extfl > 0) : 1, 
-                               args_unboxed, jitter->unbox, dest);
-    CHECK_LIMIT();
-    ref3 = NULL;
-    ref = NULL;
-    ref4 = NULL;
-
-    if ((arith == ARITH_INEX_EX) && (unsafe_extfl < 1)) {
-      /* need a slow path */
-      if (args_unboxed) {
-        (void)jit_calli(sjc.box_extflonum_from_reg_code);
-      }
-      generate_arith_slow_path(jitter, rator, &ref, &ref4, for_branch, branch_short, orig_args, reversed, arith, 0, 0, dest);
-      /* assert: !ref4, since not for_branch */
-      __START_SHORT_JUMPS__(branch_short);
-      mz_patch_ucbranch(ref);
-      mz_patch_ucbranch(refdt);
-      __END_SHORT_JUMPS__(branch_short);
-    }
-
-    __START_SHORT_JUMPS__(branch_short);
-  } else {
-    int unbox = jitter->unbox;
-
-    if (unsafe_extfl < 0) {
-      has_fixnum_fast = 0;
-      unsafe_extfl = 0;
-    }
-
-    /* While generating a fixnum op, don't unbox! */
-    jitter->unbox = 0;
-
-    if (!rand) {
-      /* generating for an nary operation; first arg in R0, 
-         second in R1 */
-      reversed = 1;
-      cmp = -cmp;
-      refslow = overflow_refslow;
-      refd = NULL;
-      refdt = NULL;
-      ref3 = NULL;
-      ref = NULL;
-      ref4 = NULL;
-    } else {
-      if (!unsafe_extfl
-          && ((arith == ARITH_MIN)
-              || (arith == ARITH_MAX)
-              || (arith == ARITH_AND)
-              || (arith == ARITH_IOR)
-              || (arith == ARITH_XOR))) {
-        /* No slow path necessary for fixnum arguments. */
-        if (scheme_jit_is_fixnum(rand) && (!rand2 || scheme_jit_is_fixnum(rand2))) {
-          unsafe_fx = 1;
-        }
-      }
-
-      if (rand2) {
-        if (SCHEME_INTP(rand2)
-            && SCHEME_INT_SMALL_ENOUGH(rand2)
-            && ((arith != ARITH_LSH)
-                || ((SCHEME_INT_VAL(rand2) <= MAX_TRY_SHIFT)
-                    && (SCHEME_INT_VAL(rand2) >= -MAX_TRY_SHIFT)))
-            && ((cmp != 3)
-                || ((SCHEME_INT_VAL(rand2) <= MAX_TRY_SHIFT)
-                    && (SCHEME_INT_VAL(rand2) >= 0)))) {
-          /* Second is constant, so use constant mode.
-             For arithmetic shift, only do this if the constant
-             is in range. */
-          v = SCHEME_INT_VAL(rand2);
-          rand2 = NULL;
-        } else if (SCHEME_INTP(rand)
-                   && SCHEME_INT_SMALL_ENOUGH(rand)
-                   && (arith != ARITH_LSH) && (arith != ARITH_RSH)
-                   && (cmp != CMP_BIT)) {
-          /* First is constant; swap argument order and use constant mode. */
-          v = SCHEME_INT_VAL(rand);
-          cmp = -cmp;
-          rand = rand2;
-          rand2 = NULL;
-          reversed = 1;
-        } else if ((scheme_ok_to_move_local(rand2)
-                    || SCHEME_INTP(rand2))
-                   && !(scheme_ok_to_move_local(rand)
-                        || SCHEME_INTP(rand))) {
-          /* Second expression is side-effect-free, unlike the first; 
-             swap order and use the fast path for when the first arg is
-             side-effect free. */
-          Scheme_Object *t = rand2;
-          rand2 = rand;
-          rand = t;
-          cmp = -cmp;
-          reversed = 1;
-        }
-      }
-
-      if ((arith == ARITH_SUB) && (orig_args == 1) && !v) {
-        /* Unary subtract */
-        reversed = 1;
-      }
-
-      if (!unsafe_extfl && !unsafe_fx 
-          && (scheme_jit_is_fixnum(rand) && (!rand2 || scheme_jit_is_fixnum(rand2)))) {
-        /* Since we'll get a fix num, skip extflonum variant */
-        has_extflonum_fast = 0;
-      }
-
-      if (rand2) {
-        int dir;
-        dir = scheme_generate_two_args(rand, rand2, jitter, 0, orig_args);
-        CHECK_LIMIT();
-        /* Since we want rand in R1 and rand2 in R0, direction is backwards: */
-        if (dir > 0) {
-          Scheme_Object *t = rand2;
-          rand2 = rand;
-          rand = t;
-          cmp = -cmp;
-          reversed = !reversed;
-        }
-      } else {
-        mz_runstack_skipped(jitter, orig_args);
-        scheme_generate_non_tail(rand, jitter, 0, 1, 0); /* sync'd later */
-        CHECK_LIMIT();
-        mz_runstack_unskipped(jitter, orig_args);
-        CHECK_RUNSTACK_OVERFLOW();
-      }
-      /* not sync'd... */
-
-      /* two arguments: rand2 in R0, and rand in R1 */
-      /* one argument: rand in R0 */
-
-      if (rand2) {
-        int va;
-
-        if (scheme_jit_is_fixnum(rand)) {
-          if (scheme_jit_is_fixnum(rand2))
-            va = -1; /* no check needed */
-          else
-            va = JIT_R0; /* check only rand2 */
-        } else if (scheme_jit_is_fixnum(rand2)) {
-          va = JIT_R1; /* check only rand */
-        } else {
-          if (!unsafe_fx && !unsafe_extfl) {
-            /* check both fixnum bits at once by ANDing into R2: */
-            jit_andr_ul(JIT_R2, JIT_R0, JIT_R1);
-            va = JIT_R2;
-          } else
-            va =  -1;
-        }
-
-        if (!unsafe_fx && !unsafe_extfl) {
-          mz_rs_sync();
-
-          __START_TINY_JUMPS_IF_COMPACT__(1);
-          if (va == -1)
-            ref2 = jit_jmpi(jit_forward());
-          else
-            ref2 = jit_bmsi_ul(jit_forward(), va, 0x1);
-          __END_TINY_JUMPS_IF_COMPACT__(1);
-        } else {
-          ref2 = NULL;
-          if (for_branch) mz_rs_sync();
-        }
-
-        if (unsafe_extfl || (!unsafe_fx && !SCHEME_INTP(rand) 
-                          && has_extflonum_fast 
-                          && can_fast_double(arith, cmp, 1))) {
-          /* Maybe they're both doubles... */
-          if (unsafe_extfl) mz_rs_sync();
-          generate_long_double_arith(jitter, rator, arith, cmp, reversed, 1, 0, &refd, &refdt, 
-                                     for_branch, branch_short, unsafe_extfl, 0, unbox, dest);
-          CHECK_LIMIT();
-        }
-
-        if (!unsafe_fx && !unsafe_extfl) {
-          if (!has_fixnum_fast) {
-            __START_TINY_JUMPS_IF_COMPACT__(1);
-            if (va == -1)
-              mz_patch_ucbranch(ref2);
-            else
-              mz_patch_branch(ref2);
-            __END_TINY_JUMPS_IF_COMPACT__(1);
-          }
-
-          /* Slow path */
-          refslow = generate_arith_slow_path(jitter, rator, &ref, &ref4, for_branch, branch_short, 
-                                             orig_args, reversed, arith, 0, 0, dest);
-
-          if (has_fixnum_fast) {
-            __START_TINY_JUMPS_IF_COMPACT__(1);
-            if (va == -1)
-              mz_patch_ucbranch(ref2);
-            else
-              mz_patch_branch(ref2);
-            __END_TINY_JUMPS_IF_COMPACT__(1);
-          }
-        } else {
-          refslow = overflow_refslow;
-          ref = NULL;
-          ref4 = NULL;
-        }
-        CHECK_LIMIT();
-      } else {
-        /* Only one argument: */
-        int is_fx;
-
-        is_fx = scheme_jit_is_fixnum(rand);
-
-        if (!unsafe_fx && !unsafe_extfl) {
-          mz_rs_sync();
-          __START_TINY_JUMPS_IF_COMPACT__(1);
-          if (is_fx)
-            ref2 = jit_jmpi(jit_forward());
-          else
-            ref2 = jit_bmsi_ul(jit_forward(), JIT_R0, 0x1);
-          __END_TINY_JUMPS_IF_COMPACT__(1);
-        } else {
-          if (for_branch) mz_rs_sync();
-          ref2 = NULL;
-        }
-
-        if (unsafe_extfl
-            || ((orig_args != 2) /* <- heuristic: we could generate code when an exact argument is
-                                    given, but the extra FP code is probably not worthwhile. */
-                && !unsafe_fx
-                && has_extflonum_fast
-                && can_fast_double(arith, cmp, 0)
-                /* watch out: divide by 0 is special: */
-                && ((arith != ARITH_DIV) || v || reversed))) {
-          /* Maybe it's a double... */
-          generate_long_double_arith(jitter, rator, arith, cmp, reversed, 0, v, &refd, &refdt, 
-                                     for_branch, branch_short, unsafe_extfl, 0, unbox, dest);
-          CHECK_LIMIT();
-        }
-
-        if (!unsafe_fx && !unsafe_extfl) {
-          if (!has_fixnum_fast) {
-            __START_TINY_JUMPS_IF_COMPACT__(1);
-            if (is_fx)
-              mz_patch_ucbranch(ref2);
-            else
-              mz_patch_branch(ref2);
-            __END_TINY_JUMPS_IF_COMPACT__(1);
-          }
-
-          /* Slow path */
-          refslow = generate_arith_slow_path(jitter, rator, &ref, &ref4, for_branch, branch_short, 
-                                             orig_args, reversed, arith, 1, v, dest);
-
-          if (has_fixnum_fast) {
-            __START_TINY_JUMPS_IF_COMPACT__(1);
-            if (is_fx)
-              mz_patch_ucbranch(ref2);
-            else
-              mz_patch_branch(ref2);
-            __END_TINY_JUMPS_IF_COMPACT__(1);
-          }
-        } else {
-          refslow = overflow_refslow;
-          ref = NULL;
-          ref4 = NULL;
-        }
-      }
-
-      CHECK_LIMIT();
-    }
-
-    __START_SHORT_JUMPS__(branch_short);
-
-    if (!unsafe_extfl) {
-      if (arith) {
-        if (((arith == ARITH_DIV) || (arith == ARITH_QUOT) || (arith == ARITH_REM) || (arith == ARITH_MOD)) && !rand2) {
-          (void)jit_movi_p(JIT_R1, scheme_make_integer(v));
-          rand2 = scheme_true;
-          reversed = !reversed;
-        }
-
-        if (rand2) {
-          /* First arg is in JIT_R1, second is in JIT_R0 */
-          if (arith == ARITH_ADD) {
-            jit_andi_ul(JIT_R2, JIT_R1, (~0x1));
-            if (unsafe_fx && !overflow_refslow)
-              jit_addr_l(dest, JIT_R2, JIT_R0);
-            else {
-              (void)jit_boaddr_l(refslow, JIT_R2, JIT_R0);
-              jit_movr_p(dest, JIT_R2);
-            }
-          } else if (arith == ARITH_SUB) {
-            if (reversed) {
-              jit_movr_p(JIT_R2, JIT_R0);
-              if (unsafe_fx && !overflow_refslow)
-                jit_subr_l(JIT_R2, JIT_R2, JIT_R1);
-              else
-                (void)jit_bosubr_l(refslow, JIT_R2, JIT_R1);
-            } else {
-              jit_movr_p(JIT_R2, JIT_R1);
-              if (unsafe_fx && !overflow_refslow)
-                (void)jit_subr_l(JIT_R2, JIT_R2, JIT_R0);
-              else
-                (void)jit_bosubr_l(refslow, JIT_R2, JIT_R0);
-            }
-            jit_ori_ul(dest, JIT_R2, 0x1);
-          } else if (arith == ARITH_MUL) {
-            jit_andi_ul(JIT_R2, JIT_R1, (~0x1));
-            jit_rshi_l(JIT_V1, JIT_R0, 0x1);
-            if (unsafe_fx && !overflow_refslow)
-              jit_mulr_l(JIT_V1, JIT_V1, JIT_R2);
-            else
-              (void)jit_bomulr_l(refslow, JIT_V1, JIT_R2);
-            jit_ori_ul(dest, JIT_V1, 0x1);
-          } else if ((arith == ARITH_DIV) || (arith == ARITH_QUOT) || (arith == ARITH_REM) || (arith == ARITH_MOD)) {
-            if (reversed) {
-              jit_rshi_l(JIT_V1, JIT_R0, 0x1);
-              jit_rshi_l(JIT_R2, JIT_R1, 0x1);
-            } else {
-              jit_rshi_l(JIT_R2, JIT_R0, 0x1);
-              jit_rshi_l(JIT_V1, JIT_R1, 0x1);
-            }
-            if (!unsafe_fx || overflow_refslow)
-              (void)jit_beqi_l(refslow, JIT_R2, 0);
-
-            if (arith == ARITH_MOD) {
-              generate_modulo_setup(jitter, branch_short, JIT_V1, JIT_R2);
-              CHECK_LIMIT();
-            }
-            if ((arith == ARITH_DIV) || (arith == ARITH_QUOT))
-              jit_divr_l(JIT_R0, JIT_V1, JIT_R2);
-            else
-              jit_modr_l(JIT_R0, JIT_V1, JIT_R2);
-
-            if (arith == ARITH_DIV) {
-              GC_CAN_IGNORE jit_insn *refx;
-              if (reversed)
-                jit_mulr_l(JIT_R2, JIT_R0, JIT_R2);
-              else
-                jit_mulr_l(JIT_V1, JIT_R0, JIT_V1);
-              __START_INNER_TINY__(branch_short);
-              refx = jit_beqr_l(jit_forward(), JIT_R2, JIT_V1);
-              __END_INNER_TINY__(branch_short);
-              /* restore R0 argument: */
-              if (reversed) {
-                jit_fixnum_l(JIT_R0, JIT_V1);
-              } else {
-                jit_fixnum_l(JIT_R0, JIT_R2);
-              }
-              (void)jit_jmpi(refslow);
-              __START_INNER_TINY__(branch_short);
-              mz_patch_branch(refx);
-              __END_INNER_TINY__(branch_short);
-            } else if (arith == ARITH_MOD) {
-              GC_CAN_IGNORE jit_insn *refx, *refy;
-              __START_INNER_TINY__(branch_short);
-              refy = jit_beqi_l(jit_forward(), JIT_R0, 0);
-              refx = jit_bmci_l(jit_forward(), JIT_R1, 0x1);
-              jit_subr_l(JIT_R0, JIT_R2, JIT_R0);
-              mz_patch_branch(refx);
-              refx = jit_bmci_l(jit_forward(), JIT_R1, 0x2);
-              jit_negr_l(JIT_R0, JIT_R0);
-              mz_patch_branch(refx);
-              mz_patch_branch(refy);
-              __END_INNER_TINY__(branch_short);
-            } else if (arith == ARITH_QUOT) {
-              /* watch out for negation of most negative fixnum,
-                 which is a positive number too big for a fixnum */
-              if (!unsafe_fx || overflow_refslow) {
-                GC_CAN_IGNORE jit_insn *refx;
-                __START_INNER_TINY__(branch_short);
-                refx = jit_bnei_l(jit_forward(), JIT_R0, (void *)(((intptr_t)1 << ((8 * JIT_WORD_SIZE) - 2))));
-                __END_INNER_TINY__(branch_short);
-                /* first argument must have been most negative fixnum, 
-                   second argument must have been -1: */
-                if (reversed)
-                  (void)jit_movi_p(JIT_R0, (void *)(((intptr_t)1 << ((8 * JIT_WORD_SIZE) - 1)) | 0x1));
-                else
-                  (void)jit_movi_p(JIT_R0, scheme_make_integer(-1));
-                (void)jit_jmpi(refslow);
-                __START_INNER_TINY__(branch_short);
-                mz_patch_branch(refx);
-                __END_INNER_TINY__(branch_short);
-              }
-            }
-            jit_fixnum_l(dest, JIT_R0);
-          } else if (arith == ARITH_AND) {
-            /* and */
-            jit_andr_ul(dest, JIT_R1, JIT_R0);
-          } else if (arith == ARITH_IOR) {
-            /* ior */
-            jit_orr_ul(dest, JIT_R1, JIT_R0);
-          } else if (arith == ARITH_XOR) {
-            /* xor */
-            jit_andi_ul(JIT_R0, JIT_R0, (~0x1));
-            jit_xorr_ul(dest, JIT_R1, JIT_R0);
-          } else if ((arith == ARITH_LSH) || (arith == ARITH_RSH)) {
-            /* arithmetic-shift 
-               This is a lot of code, but if you're using
-               arithmetic-shift, then you probably want it. */
-            int v1 = (reversed ? JIT_R0 : JIT_R1);
-            int v2 = (reversed ? JIT_R1 : JIT_R0);
-            GC_CAN_IGNORE jit_insn *refi, *refc;
-
-            if ((arith != ARITH_RSH) && (!unsafe_fx || overflow_refslow))
-              refi = jit_bgei_l(jit_forward(), v2, (intptr_t)scheme_make_integer(0));
-            else
-              refi = NULL;
-
-            if (!unsafe_fx || overflow_refslow || (arith == ARITH_RSH)) {
-              /* Right shift */
-              if (!unsafe_fx || overflow_refslow) {
-                /* check for a small enough shift */
-                if (arith == ARITH_RSH) {
-                  (void)jit_blti_l(refslow, v2, scheme_make_integer(0));
-                  (void)jit_bgti_l(refslow, v2, scheme_make_integer(MAX_TRY_SHIFT));
-                  jit_rshi_l(JIT_V1, v2, 0x1);
-                } else {
-                  (void)jit_blti_l(refslow, v2, scheme_make_integer(-MAX_TRY_SHIFT));
-                  jit_notr_l(JIT_V1, v2);
-                  jit_rshi_l(JIT_V1, JIT_V1, 0x1);
-                  jit_addi_l(JIT_V1, JIT_V1, 0x1);
-                }
-              } else {
-                jit_rshi_l(JIT_V1, v2, 0x1);
-              }
-              CHECK_LIMIT();
-#ifdef MZ_USE_JIT_I386
-              /* Can't shift from _ECX */
-              jit_movr_l(JIT_R2, v1);
-              jit_rshr_l(JIT_R2, JIT_R2, JIT_V1);
-#else
-              jit_rshr_l(JIT_R2, v1, JIT_V1);
-#endif
-              jit_ori_l(dest, JIT_R2, 0x1);
-              if (!unsafe_fx || overflow_refslow)
-                refc = jit_jmpi(jit_forward());
-              else
-                refc = NULL;
-              CHECK_LIMIT();
-            } else
-              refc = NULL;
-
-            /* Left shift */
-            if (!unsafe_fx || overflow_refslow || (arith == ARITH_LSH)) {
-              if (refi)
-                mz_patch_branch(refi);
-              if (!unsafe_fx || overflow_refslow)
-                (void)jit_bgti_l(refslow, v2, (intptr_t)scheme_make_integer(MAX_TRY_SHIFT));
-              jit_rshi_l(JIT_V1, v2, 0x1);
-              jit_andi_l(v1, v1, (~0x1));
-#ifdef MZ_USE_JIT_I386
-              /* Can't shift from _ECX */
-              jit_movr_l(JIT_R2, v1);
-              jit_lshr_l(JIT_R2, JIT_R2, JIT_V1);
-#else
-              jit_lshr_l(JIT_R2, v1, JIT_V1);
-#endif
-              CHECK_LIMIT();
-              /* If shifting back right produces a different result, that's overflow... */
-              jit_rshr_l(JIT_V1, JIT_R2, JIT_V1);
-              /* !! In case we go refslow, it needs to add back tag to v1 !! */
-              if (!unsafe_fx || overflow_refslow)
-                (void)jit_bner_p(refslow, JIT_V1, v1);
-              /* No overflow. */
-              jit_ori_l(dest, JIT_R2, 0x1);
-            }
-
-            if (refc)
-              mz_patch_ucbranch(refc);
-          } else if (arith == ARITH_MIN) {
-            /* min */
-            GC_CAN_IGNORE jit_insn *refc;
-            __START_INNER_TINY__(branch_short);
-            refc = jit_bltr_l(jit_forward(), JIT_R0, JIT_R1);
-            jit_movr_l(JIT_R0, JIT_R1);
-            mz_patch_branch(refc);
-            jit_movr_p(dest, JIT_R0);
-            __END_INNER_TINY__(branch_short);
-          } else if (arith == ARITH_MAX) {
-            /* max */
-            GC_CAN_IGNORE jit_insn *refc;
-            __START_INNER_TINY__(branch_short);
-            refc = jit_bgtr_l(jit_forward(), JIT_R0, JIT_R1);
-            jit_movr_l(JIT_R0, JIT_R1);
-            mz_patch_branch(refc);
-            jit_movr_p(dest, JIT_R0);
-            __END_INNER_TINY__(branch_short);
-          }
-        } else {
-          /* Non-constant arg is in JIT_R0 */
-          if (arith == ARITH_ADD) {
-            if (unsafe_fx && !overflow_refslow)
-              jit_addi_l(dest, JIT_R0, v << 1);
-            else {
-              jit_movr_p(JIT_R2, JIT_R0);
-              (void)jit_boaddi_l(refslow, JIT_R2, v << 1);
-              jit_movr_p(dest, JIT_R2);
-            }
-          } else if (arith == ARITH_SUB) {
-            if (reversed) {
-              (void)jit_movi_p(JIT_R2, scheme_make_integer(v));
-              if (unsafe_fx && !overflow_refslow)
-                jit_subr_l(JIT_R2, JIT_R2, JIT_R0);
-              else
-                (void)jit_bosubr_l(refslow, JIT_R2, JIT_R0);
-              jit_addi_ul(dest, JIT_R2, 0x1);
-            } else {
-              if (unsafe_fx && !overflow_refslow)
-                jit_subi_l(dest, JIT_R0, v << 1);
-              else {
-                jit_movr_p(JIT_R2, JIT_R0);
-                (void)jit_bosubi_l(refslow, JIT_R2, v << 1);
-                jit_movr_p(dest, JIT_R2);
-              }
-            }
-          } else if (arith == ARITH_MUL) {
-            if (v == 1) {
-              /* R0 already is the answer */
-              jit_movr_p(dest, JIT_R0);
-            } else if (v == 0) {
-              (void)jit_movi_p(dest, scheme_make_integer(0));
-            } else {
-              (void)jit_movi_l(JIT_R2, ((intptr_t)scheme_make_integer(v) & (~0x1)));
-              jit_rshi_l(JIT_V1, JIT_R0, 0x1);
-              if (unsafe_fx && !overflow_refslow)
-                jit_mulr_l(JIT_V1, JIT_V1, JIT_R2);
-              else {
-                (void)jit_movi_p(JIT_R1, scheme_make_integer(v)); /* for slow path */
-                (void)jit_bomulr_l(refslow, JIT_V1, JIT_R2);
-              }
-              jit_ori_ul(dest, JIT_V1, 0x1);
-            }
-          } else {
-            if (arith == ARITH_AND) {
-              /* and */
-              intptr_t l = (intptr_t)scheme_make_integer(v);
-              jit_andi_ul(dest, JIT_R0, l);
-            } else if (arith == ARITH_IOR) {
-              /* ior */
-              intptr_t l = (intptr_t)scheme_make_integer(v);
-              jit_ori_ul(dest, JIT_R0, l);
-            } else if (arith == ARITH_XOR) {
-              /* xor */
-              jit_xori_ul(dest, JIT_R0, v << 1);
-            } else if ((arith == ARITH_LSH) || (arith == ARITH_RSH)) {
-              /* arithmetic-shift */
-              /* We only get here when v is between -MAX_TRY_SHIFT and MAX_TRY_SHIFT, inclusive */
-              if ((v <= 0) || (arith == ARITH_RSH)) {
-                int amt = v;
-                if (arith != ARITH_RSH) 
-                  amt = -amt;
-                jit_rshi_l(JIT_R0, JIT_R0, amt);
-                jit_ori_l(dest, JIT_R0, 0x1);
-              } else {
-                jit_andi_l(JIT_R0, JIT_R0, (~0x1));
-                jit_lshi_l(JIT_R2, JIT_R0, v);
-                if (!unsafe_fx && !overflow_refslow) {
-                  /* If shifting back right produces a different result, that's overflow... */
-                  jit_rshi_l(JIT_V1, JIT_R2, v);
-                  /* !! In case we go refslow, it nseed to add back tag to JIT_R0 !! */
-                  (void)jit_bner_p(refslow, JIT_V1, JIT_R0);
-                }
-                /* No overflow. */
-                jit_ori_l(dest, JIT_R2, 0x1);
-              }
-            } else if (arith == ARITH_NOT) {
-              jit_notr_ul(JIT_R0, JIT_R0);
-              jit_ori_ul(dest, JIT_R0, 0x1);
-            } else if (arith == ARITH_MIN) {
-              /* min */
-              GC_CAN_IGNORE jit_insn *refc;
-              __START_INNER_TINY__(branch_short);
-              refc = jit_blti_l(jit_forward(), JIT_R0, (intptr_t)scheme_make_integer(v));
-              jit_movi_l(JIT_R0, (intptr_t)scheme_make_integer(v));
-              mz_patch_branch(refc);
-              jit_movr_p(dest, JIT_R0);
-              __END_INNER_TINY__(branch_short);
-            } else if (arith == ARITH_MAX) {
-              /* max */
-              GC_CAN_IGNORE jit_insn *refc;
-              __START_INNER_TINY__(branch_short);
-              refc = jit_bgti_l(jit_forward(), JIT_R0, (intptr_t)scheme_make_integer(v));
-              jit_movi_l(JIT_R0, (intptr_t)scheme_make_integer(v));
-              mz_patch_branch(refc);
-              jit_movr_p(dest, JIT_R0);
-              __END_INNER_TINY__(branch_short);
-            } else if (arith == ARITH_ABS) {
-              /* abs */
-              GC_CAN_IGNORE jit_insn *refc;
-              __START_INNER_TINY__(branch_short);
-              refc = jit_bgei_l(jit_forward(), JIT_R0, (intptr_t)scheme_make_integer(0));
-              __END_INNER_TINY__(branch_short);
-              /* watch out for most negative fixnum! */
-              if (!unsafe_fx || overflow_refslow)
-                (void)jit_beqi_p(refslow, JIT_R0, (void *)(((intptr_t)1 << ((8 * JIT_WORD_SIZE) - 1)) | 0x1));
-              (void)jit_movi_p(JIT_R1, scheme_make_integer(0));
-              jit_subr_l(JIT_R0, JIT_R1, JIT_R0);
-              jit_ori_l(JIT_R0, JIT_R0, 0x1);
-              __START_INNER_TINY__(branch_short);
-              mz_patch_branch(refc);
-              jit_movr_p(dest, JIT_R0);
-              __END_INNER_TINY__(branch_short);
-              CHECK_LIMIT();
-            } else if (arith == ARITH_EX_INEX) {
-              /* exact->inexact */
-              int fpr0;
-              fpr0 = JIT_FPU_FPR_0(jitter->unbox_depth);
-              jit_rshi_l(JIT_R0, JIT_R0, 1);
-              jit_fpu_extr_l_ld_fppush(fpr0, JIT_R0);
-              CHECK_LIMIT();
-              if (!unbox) {
-                mz_rs_sync(); /* needed for unsafe op before allocation */
-                __END_SHORT_JUMPS__(branch_short);
-                scheme_generate_alloc_long_double(jitter, 0, dest);
-                __START_SHORT_JUMPS__(branch_short);
-              } else {
-                jitter->unbox_depth++;
-              }
-              CHECK_LIMIT();
-            } else if (arith == ARITH_INEX_EX) {
-              /* inexact->exact */
-              /* no work to do, since fixnum is already exact */
-              jit_movr_p(dest, JIT_R0);
-            }
-          }
-        }
-        if (refdt)
-          mz_patch_ucbranch(refdt);
-        if (!unsafe_fx && !unsafe_extfl)
-          mz_patch_ucbranch(ref);
-        ref3 = NULL;
-      } else {
-        /* If second is constant, first arg is in JIT_R0. */
-        /* Otherwise, first arg is in JIT_R1, second is in JIT_R0 */
-        /* Jump to ref3 to produce false */
-        int rs_valid, rs_can_keep = 0;
-
-        if (for_branch) {
-          scheme_prepare_branch_jump(jitter, for_branch);
-          CHECK_LIMIT();
-        }
-
-        rs_valid = mz_CURRENT_REG_STATUS_VALID();
-
+#ifdef MZ_LONG_DOUBLE
+      if (call_for_extfl) {
         switch (cmp) {
-        case CMP_ODDP:
-          ref3 = jit_bmci_l(jit_forward(), JIT_R0, 0x2);
-          rs_can_keep = 1;
+        case CMP_LT:
+          refd = jit_fpu_bantigtr_ld_fppop(jit_forward(), fpr0, fpr1);
           break;
-        case -CMP_BIT:
-          if (rand2) {
-            if (!unsafe_fx || overflow_refslow) {
-              (void)jit_blti_l(refslow, JIT_R1, 0);
-              (void)jit_bgti_l(refslow, JIT_R1, (intptr_t)scheme_make_integer(MAX_TRY_SHIFT));
-            }
-            jit_rshi_l(JIT_R1, JIT_R1, 1);
-            jit_addi_l(JIT_V1, JIT_R1, 1);
-            jit_movi_l(JIT_R2, 1);
-            jit_lshr_l(JIT_R2, JIT_R2, JIT_V1);
-            ref3 = jit_bmcr_l(jit_forward(), JIT_R0, JIT_R2);
-          } else {
-            /* shouldn't get here */
-            scheme_signal_error("internal error: bitwise-bit-test? constant in wrong position");
-            ref3 = NULL;
-          }
+        case CMP_LEQ:
+          refd = jit_fpu_bantiger_ld_fppop(jit_forward(), fpr0, fpr1);
+          break;
+        case CMP_EQUAL:
+          refd = jit_fpu_bantieqr_ld_fppop(jit_forward(), fpr0, fpr1);
+          break;
+        case CMP_GEQ:
+          refd = jit_fpu_bantiler_ld_fppop(jit_forward(), fpr0, fpr1);
+          break;
+        case CMP_GT:
+          refd = jit_fpu_bantiltr_ld_fppop(jit_forward(), fpr0, fpr1);
+          break;
+        default:
+          refd = NULL;
           break;
+        }
+      } else
+#endif
+        {
+        switch (cmp) {
         case CMP_LT:
-          if (rand2) {
-            ref3 = jit_bger_l(jit_forward(), JIT_R1, JIT_R0);
-          } else {
-            ref3 = jit_bgei_l(jit_forward(), JIT_R0, (intptr_t)scheme_make_integer(v));
-          }
-          rs_can_keep = 1;
+          refd = jit_bantigtr_d_fppop(jit_forward(), fpr0, fpr1);
           break;
         case CMP_LEQ:
-          if (rand2) {
-            ref3 = jit_bgtr_l(jit_forward(), JIT_R1, JIT_R0);
-          } else {
-            ref3 = jit_bgti_l(jit_forward(), JIT_R0, (intptr_t)scheme_make_integer(v));
-          }
-          rs_can_keep = 1;
+          refd = jit_bantiger_d_fppop(jit_forward(), fpr0, fpr1);
           break;
         case CMP_EQUAL:
-          if (rand2) {
-            ref3 = jit_bner_l(jit_forward(), JIT_R1, JIT_R0);
-          } else {
-            ref3 = jit_bnei_l(jit_forward(), JIT_R0, (intptr_t)scheme_make_integer(v));
-          }
-          rs_can_keep = 1;
+          refd = jit_bantieqr_d_fppop(jit_forward(), fpr0, fpr1);
           break;
         case CMP_GEQ:
-          if (rand2) {
-            ref3 = jit_bltr_l(jit_forward(), JIT_R1, JIT_R0);
-          } else {
-            ref3 = jit_blti_l(jit_forward(), JIT_R0, (intptr_t)scheme_make_integer(v));
-          }
-          rs_can_keep = 1;
+          refd = jit_bantiler_d_fppop(jit_forward(), fpr0, fpr1);
           break;
         case CMP_GT:
-          if (rand2) {
-            ref3 = jit_bler_l(jit_forward(), JIT_R1, JIT_R0);
-          } else {
-            ref3 = jit_blei_l(jit_forward(), JIT_R0, (intptr_t)scheme_make_integer(v));
-          }
-          rs_can_keep = 1;
+          refd = jit_bantiltr_d_fppop(jit_forward(), fpr0, fpr1);
           break;
         default:
-        case CMP_BIT:
-          if (rand2) {
-            if (!unsafe_fx || overflow_refslow) {
-              (void)jit_blti_l(refslow, JIT_R0, 0);
-              (void)jit_bgti_l(refslow, JIT_R0, (intptr_t)scheme_make_integer(MAX_TRY_SHIFT));
-            }
-            jit_rshi_l(JIT_R0, JIT_R0, 1);
-            jit_addi_l(JIT_R0, JIT_R0, 1);
-            jit_movi_l(JIT_V1, 1);
-            jit_lshr_l(JIT_R0, JIT_V1, JIT_R0);
-            ref3 = jit_bmcr_l(jit_forward(), JIT_R1, JIT_R0);
-          } else {
-            ref3 = jit_bmci_l(jit_forward(), JIT_R0, 1 << (v+1));
-            rs_can_keep = 1;
-          }
-          break;
-        case CMP_EVENP:
-          ref3 = jit_bmsi_l(jit_forward(), JIT_R0, 0x2);
-          rs_can_keep = 1;
+          refd = NULL;
           break;
         }
-
-        mz_SET_REG_STATUS_VALID(rs_valid && rs_can_keep);
       }
-    } else {
-      ref3 = NULL;
+      R0_FP_ADJUST(_jitl.r0_can_be_tmp--);
+      __END_SHORT_JUMPS__(branch_short);
+      *_refd = refd;
     }
+  }
 
-    jitter->unbox = unbox;
+  if (!unsafe_fl) {
+    /* Jump to return result or true branch: */
+    __START_SHORT_JUMPS__(branch_short);
+    refdt = jit_jmpi(jit_forward());
+    *_refdt = refdt;
+    __END_SHORT_JUMPS__(branch_short);
   }
 
-  if (!arith) {
-    if (for_branch) {
-      if (refdt) {
-        scheme_add_or_patch_branch_true_uc(jitter, for_branch, refdt);
-        CHECK_LIMIT();
-      }
-      if (ref4) {
-        scheme_add_or_patch_branch_true_movi(jitter, for_branch, ref4);
-        CHECK_LIMIT();
+  if (!unsafe_fl) {
+    /* No, they're not both doubles, or slow path is needed
+       for some other reason. */
+    __START_TINY_JUMPS__(1);
+    if (!unboxed) {
+      if (two_args) {
+        mz_patch_branch(ref8);
+        mz_patch_branch(ref10);
       }
-      scheme_add_branch_false(for_branch, ref3);
-      scheme_add_branch_false(for_branch, refd);
-      scheme_add_branch_false_movi(for_branch, ref);
-      scheme_branch_for_true(jitter, for_branch);
-      CHECK_LIMIT();
-    } else {
-      if (refdt)
-        mz_patch_ucbranch(refdt);
-
-      (void)jit_movi_p(dest, scheme_true);
-      __START_INNER_TINY__(branch_short);
-      ref2 = jit_jmpi(jit_forward());
-      __END_INNER_TINY__(branch_short);
-      if (ref3)
-        mz_patch_branch(ref3);
-      if (refd)
-        mz_patch_branch(refd);
-      (void)jit_movi_p(dest, scheme_false);
-      __START_INNER_TINY__(branch_short);
-      mz_patch_ucbranch(ref2);
-      __END_INNER_TINY__(branch_short);
-      if (!unsafe_fx && !unsafe_extfl)
-        mz_patch_ucbranch(ref);
+      mz_patch_branch(ref9);
     }
+    if (refs)
+      mz_patch_branch(refs);
+    if (refs2)
+      mz_patch_branch(refs2);
+    __END_TINY_JUMPS__(1);
   }
+#endif
+  
+  return 1;
+}
 
-  __END_SHORT_JUMPS__(branch_short);
+static int check_float_type_result(mz_jit_state *jitter, int reg, void *fail_code, Scheme_Object *rator, int type)
+/* Doesn't use R0 or R1, except for `reg' */
+{
+  /* Check for flonum result */
+  GC_CAN_IGNORE jit_insn *ref, *reffail;
+
+  mz_rs_sync();
+
+  __START_TINY_JUMPS__(1);
+  ref = jit_bmci_l(jit_forward(), reg, 0x1);
+  __END_TINY_JUMPS__(1);
+
+  reffail = _jit.x.pc;
+  (void)jit_movi_p(JIT_V1, ((Scheme_Primitive_Proc *)rator)->prim_val);
+  (void)jit_calli(fail_code);
+
+  __START_TINY_JUMPS__(1);
+  mz_patch_branch(ref);
+  __END_TINY_JUMPS__(1);
+
+  jit_ldxi_s(JIT_R2, JIT_R0, &((Scheme_Object *)0x0)->type);
+  __START_SHORT_JUMPS__(1);
+  (void)jit_bnei_i(reffail, JIT_R2, type);
+  __END_SHORT_JUMPS__(1);
+  CHECK_LIMIT();
+
+  scheme_generate_unboxing(jitter, reg);
 
   return 1;
 }
+
+static int check_flonum_result(mz_jit_state *jitter, int reg, void *fail_code, Scheme_Object *rator)
+/* Doesn't use R0 or R1, except for `reg' */
+{
+  return check_float_type_result(jitter, reg, fail_code, rator, scheme_double_type);
+}
+
+#ifdef MZ_LONG_DOUBLE
+static int check_extflonum_result(mz_jit_state *jitter, int reg, void *fail_code, Scheme_Object *rator)
+/* Doesn't use R0 or R1, except for `reg' */
+{
+  return check_float_type_result(jitter, reg, fail_code, rator, scheme_long_double_type);
+}
 #endif
 
 
-int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Object *rand, Scheme_Object *rand2, 
-			  int orig_args, int arith, int cmp, int v, 
-                          Branch_Info *for_branch, int branch_short,
-                          int unsafe_fx, int unsafe_fl, GC_CAN_IGNORE jit_insn *overflow_refslow,
-                          int dest)
+static void generate_modulo_setup(mz_jit_state *jitter, int branch_short, int a1, int a2)
+/* r1 has two flags: bit 0 means two args have different sign; bit 1 means second arg is negative */
+{
+  GC_CAN_IGNORE jit_insn *refx;
+
+  jit_movi_l(JIT_R1, 0x0);
+  __START_INNER_TINY__(branch_short);
+  refx = jit_bgei_l(jit_forward(), a1, 0);
+  jit_negr_l(a1, a1);
+  jit_movi_l(JIT_R1, 0x1);
+  mz_patch_branch(refx);
+  refx = jit_bgei_l(jit_forward(), a2, 0);
+  jit_xori_l(JIT_R1, JIT_R1, 0x3);
+  jit_negr_l(a2, a2);
+  mz_patch_branch(refx);
+  __END_INNER_TINY__(branch_short);
+}
+
+int scheme_generate_arith_for(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Object *rand, Scheme_Object *rand2, 
+                              int orig_args, int arith, int cmp, int v, 
+                              Branch_Info *for_branch, int branch_short,
+                              int unsafe_fx, int unsafe_fl, GC_CAN_IGNORE jit_insn *overflow_refslow,
+                              int dest, int call_for_extfl)
 /* needs de-sync */
 /* Operation codes are defined in jit.h.
    Either arith is non-zero or it's a cmp; the value of each determines the operation:
@@ -2324,7 +1216,7 @@ int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Obj
    already in R0 (fixnum or min/max) or a floating-point register
    (flonum) and the second argument is in R1 (fixnum or min/max) or a
    floating-point register (flonum).
-   For unsafe_fx or unsafe_fl, -1 means safe but specific to the type.
+   For unsafe_fx or unsafe_fl -1 means safe but specific to the type.
 */
 {
   GC_CAN_IGNORE jit_insn *ref, *ref2, *ref3, *ref4, *refd = NULL, *refdt = NULL;
@@ -2332,6 +1224,7 @@ int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Obj
   int reversed = 0;
   int has_fixnum_fast = 1, has_flonum_fast = 1;
   int inlined_flonum1, inlined_flonum2;
+  int both_inlined;
 
   LOG_IT(("inlined %s\n", rator ? ((Scheme_Primitive_Proc *)rator)->name : "???"));
 
@@ -2342,21 +1235,40 @@ int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Obj
 
   if (unsafe_fl) {
     if (!rand) {
-      inlined_flonum1 = inlined_flonum2 = 1;
+        inlined_flonum1 = inlined_flonum2 = 1;
     } else {
-      if (scheme_can_unbox_inline(rand, 5, JIT_FPR_NUM-2, unsafe_fl > 0))
-        inlined_flonum1 = 1;
-      else
-        inlined_flonum1 = 0;
-      if (!rand2 || scheme_can_unbox_inline(rand2, 5, JIT_FPR_NUM-3, unsafe_fl > 0))
-        inlined_flonum2 = 1;
-      else
-        inlined_flonum2 = 0;
+#ifdef MZ_LONG_DOUBLE
+      if (call_for_extfl) {
+        if (scheme_can_unbox_inline(rand, 5, JIT_FPU_FPR_NUM-2, unsafe_fl > 0))
+          inlined_flonum1 = 1;
+        else
+          inlined_flonum1 = 0;
+        if (!rand2 || scheme_can_unbox_inline(rand2, 5, JIT_FPU_FPR_NUM-3, unsafe_fl > 0))
+          inlined_flonum2 = 1;
+        else
+          inlined_flonum2 = 0;
+      } else 
+#endif
+      {
+        if (scheme_can_unbox_inline(rand, 5, JIT_FPR_NUM-2, unsafe_fl > 0))
+          inlined_flonum1 = 1;
+        else
+          inlined_flonum1 = 0;
+        if (!rand2 || scheme_can_unbox_inline(rand2, 5, JIT_FPR_NUM-3, unsafe_fl > 0))
+          inlined_flonum2 = 1;
+        else
+          inlined_flonum2 = 0;
+      }
     }
   } else
     inlined_flonum1 = inlined_flonum2 = 0;
 
-  if (unsafe_fl
+  if (call_for_extfl) /* there is no extflonum unboxing, we need to check inlned_flonum1,2 */
+    both_inlined = inlined_flonum1 && inlined_flonum2;
+  else
+    both_inlined = 1;
+
+  if (unsafe_fl && both_inlined
 #ifndef USE_FLONUM_UNBOXING
       && inlined_flonum1 && inlined_flonum2
 #endif
@@ -2393,8 +1305,13 @@ int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Obj
     else 
       can_direct2 = scheme_can_unbox_directly(rand2);
 
-    if (args_unboxed)
+    if (args_unboxed) {
       jitter->unbox++;
+#ifdef MZ_LONG_DOUBLE
+      if (call_for_extfl)
+        jitter->unbox_extflonum++;
+#endif
+    }
     if (!rand) {
       CHECK_LIMIT();
       if (args_unboxed)
@@ -2407,7 +1324,12 @@ int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Obj
       CHECK_LIMIT();
       mz_runstack_unskipped(jitter, 1);
       if (!can_direct1 && (unsafe_fl <= 0)) {
-        check_flonum_result(jitter, JIT_R0, sjc.fl1_fail_code, rator);
+#ifdef MZ_LONG_DOUBLE
+        if (call_for_extfl)
+          check_extflonum_result(jitter, JIT_R0, sjc.extfl1_fail_code, rator);
+        else
+#endif
+          check_flonum_result(jitter, JIT_R0, sjc.fl1_fail_code, rator);
         CHECK_LIMIT();
       }
       flonum_depth = 1;
@@ -2423,10 +1345,12 @@ int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Obj
           mz_pushr_p(JIT_R0);
         } else if (!inlined_flonum2) {
 #ifdef USE_FLONUM_UNBOXING
-          flostack = scheme_mz_flostack_save(jitter, &flopos);
-          --jitter->unbox_depth;
-          scheme_generate_flonum_local_unboxing(jitter, 0);
-          CHECK_LIMIT();
+          if (call_for_extfl != 1) {
+            flostack = scheme_mz_flostack_save(jitter, &flopos);
+            --jitter->unbox_depth;
+            scheme_generate_flonum_local_unboxing(jitter, 0);
+            CHECK_LIMIT();
+          }
 #endif        
         }
       }
@@ -2435,27 +1359,44 @@ int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Obj
       if (!(inlined_flonum1 && inlined_flonum2)) {
         if ((can_direct1 || (unsafe_fl > 0)) && !inlined_flonum2) {
 #ifdef USE_FLONUM_UNBOXING
-          int fpr0;
-          fpr0 = JIT_FPR_0(jitter->unbox_depth);
-          mz_ld_fppush(fpr0, jitter->flostack_offset);
-          scheme_mz_flostack_restore(jitter, flostack, flopos, 1, 1);
-          CHECK_LIMIT();
-          jitter->unbox_depth++;
+          if (call_for_extfl != 1) {
+            int fpr0;
+            fpr0 = JIT_FPR_0(jitter->unbox_depth);
+            mz_ld_fppush(fpr0, jitter->flostack_offset);
+            scheme_mz_flostack_restore(jitter, flostack, flopos, 1, 1);
+            CHECK_LIMIT();
+            jitter->unbox_depth++;
+          }
 #endif
         }
         if (!can_direct2 && (unsafe_fl <= 0)) {
           jit_movr_p(JIT_R1, JIT_R0);
           if (!can_direct1) {
             mz_popr_p(JIT_R0);
-            check_flonum_result(jitter, JIT_R0, sjc.fl2rr_fail_code[fl_reversed], rator);
+#ifdef MZ_LONG_DOUBLE
+            if (call_for_extfl)
+              check_extflonum_result(jitter, JIT_R0, sjc.extfl2rr_fail_code[fl_reversed], rator);
+            else
+#endif
+              check_flonum_result(jitter, JIT_R0, sjc.fl2rr_fail_code[fl_reversed], rator);
             CHECK_LIMIT();
           }
-          check_flonum_result(jitter, JIT_R1, sjc.fl2fr_fail_code[fl_reversed], rator);
+#ifdef MZ_LONG_DOUBLE
+          if (call_for_extfl)
+            check_extflonum_result(jitter, JIT_R1, sjc.extfl2fr_fail_code[fl_reversed], rator);
+          else
+#endif
+            check_flonum_result(jitter, JIT_R1, sjc.fl2fr_fail_code[fl_reversed], rator);
           CHECK_LIMIT();
         } else {
           if (!can_direct1 && (unsafe_fl <= 0)) {
             mz_popr_p(JIT_R0);
-            check_flonum_result(jitter, JIT_R0, sjc.fl2rf_fail_code[fl_reversed], rator);
+#ifdef MZ_LONG_DOUBLE
+            if (call_for_extfl)
+              check_extflonum_result(jitter, JIT_R0, sjc.extfl2rf_fail_code[fl_reversed], rator);
+            else
+#endif
+              check_flonum_result(jitter, JIT_R0, sjc.fl2rf_fail_code[fl_reversed], rator);
             CHECK_LIMIT();
           }
           if (!(can_direct1 || (unsafe_fl > 0)) || !inlined_flonum2) {
@@ -2467,8 +1408,13 @@ int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Obj
       mz_runstack_unskipped(jitter, 2);
       flonum_depth = 2;
     }
-    if (args_unboxed)
+    if (args_unboxed) {
       --jitter->unbox;
+#ifdef MZ_LONG_DOUBLE
+      if (call_for_extfl)
+        --jitter->unbox_extflonum;
+#endif
+    }
     jitter->unbox_depth -= flonum_depth;
     if (!jitter->unbox && jitter->unbox_depth && rand)
       scheme_signal_error("internal error: broken unbox depth");
@@ -2476,10 +1422,10 @@ int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Obj
         || (arith == ARITH_INEX_EX)) /* has slow path */
       mz_rs_sync(); /* needed if arguments were unboxed */
 
-    generate_double_arith(jitter, rator, arith, cmp, reversed, !!rand2, 0,
-                          &refd, &refdt, for_branch, branch_short, 
-                          (arith == ARITH_INEX_EX) ? (unsafe_fl > 0) : 1, 
-                          args_unboxed, jitter->unbox, dest);
+    generate_float_point_arith(jitter, rator, arith, cmp, reversed, !!rand2, 0,
+                               &refd, &refdt, for_branch, branch_short, 
+                               (arith == ARITH_INEX_EX) ? (unsafe_fl > 0) : 1, 
+                               args_unboxed, jitter->unbox, dest, call_for_extfl);
     CHECK_LIMIT();
     ref3 = NULL;
     ref = NULL;
@@ -2488,7 +1434,12 @@ int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Obj
     if ((arith == ARITH_INEX_EX) && (unsafe_fl < 1)) {
       /* need a slow path */
       if (args_unboxed) {
-        (void)jit_calli(sjc.box_flonum_from_reg_code);
+#ifdef MZ_LONG_DOUBLE
+        if (call_for_extfl)
+          (void)jit_calli(sjc.box_extflonum_from_reg_code);
+        else
+#endif
+          (void)jit_calli(sjc.box_flonum_from_reg_code);
       }
       generate_arith_slow_path(jitter, rator, &ref, &ref4, for_branch, branch_short, orig_args, reversed, arith, 0, 0, dest);
       /* assert: !ref4, since not for_branch */
@@ -2646,8 +1597,8 @@ int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Obj
                           && can_fast_double(arith, cmp, 1))) {
           /* Maybe they're both doubles... */
           if (unsafe_fl) mz_rs_sync();
-          generate_double_arith(jitter, rator, arith, cmp, reversed, 1, 0, &refd, &refdt, 
-                                for_branch, branch_short, unsafe_fl, 0, unbox, dest);
+          generate_float_point_arith(jitter, rator, arith, cmp, reversed, 1, 0, &refd, &refdt, 
+                                     for_branch, branch_short, unsafe_fl, 0, unbox, dest, call_for_extfl);
           CHECK_LIMIT();
         }
 
@@ -2707,8 +1658,8 @@ int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Obj
                 /* watch out: divide by 0 is special: */
                 && ((arith != ARITH_DIV) || v || reversed))) {
           /* Maybe it's a double... */
-          generate_double_arith(jitter, rator, arith, cmp, reversed, 0, v, &refd, &refdt, 
-                                for_branch, branch_short, unsafe_fl, 0, unbox, dest);
+          generate_float_point_arith(jitter, rator, arith, cmp, reversed, 0, v, &refd, &refdt, 
+                                     for_branch, branch_short, unsafe_fl, 0, unbox, dest, call_for_extfl);
           CHECK_LIMIT();
         }
 
@@ -3079,18 +2030,37 @@ int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Obj
               CHECK_LIMIT();
             } else if (arith == ARITH_EX_INEX) {
               /* exact->inexact */
-              int fpr0;
-              fpr0 = JIT_FPR_0(jitter->unbox_depth);
-              jit_rshi_l(JIT_R0, JIT_R0, 1);
-              jit_extr_l_d_fppush(fpr0, JIT_R0);
-              CHECK_LIMIT();
-              if (!unbox) {
-                mz_rs_sync(); /* needed for unsafe op before allocation */
-                __END_SHORT_JUMPS__(branch_short);
-                scheme_generate_alloc_double(jitter, 0, dest);
-                __START_SHORT_JUMPS__(branch_short);
-              } else {
-                jitter->unbox_depth++;
+#ifdef MZ_LONG_DOUBLE
+              if (call_for_extfl) {
+                int fpr0;
+                fpr0 = JIT_FPU_FPR_0(jitter->unbox_depth);
+                jit_rshi_l(JIT_R0, JIT_R0, 1);
+                jit_fpu_extr_l_ld_fppush(fpr0, JIT_R0);
+                CHECK_LIMIT();
+                if (!unbox) {
+                  mz_rs_sync(); /* needed for unsafe op before allocation */
+                  __END_SHORT_JUMPS__(branch_short);
+                  scheme_generate_alloc_long_double(jitter, 0, dest);
+                  __START_SHORT_JUMPS__(branch_short);
+                } else {
+                  jitter->unbox_depth++;
+                }
+              } else
+#endif
+                {
+                int fpr0;
+                fpr0 = JIT_FPR_0(jitter->unbox_depth);
+                jit_rshi_l(JIT_R0, JIT_R0, 1);
+                jit_extr_l_d_fppush(fpr0, JIT_R0);
+                CHECK_LIMIT();
+                if (!unbox) {
+                  mz_rs_sync(); /* needed for unsafe op before allocation */
+                  __END_SHORT_JUMPS__(branch_short);
+                  scheme_generate_alloc_double(jitter, 0, dest);
+                  __START_SHORT_JUMPS__(branch_short);
+                } else {
+                  jitter->unbox_depth++;
+                }
               }
               CHECK_LIMIT();
             } else if (arith == ARITH_INEX_EX) {
@@ -3253,6 +2223,33 @@ int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Obj
   return 1;
 }
 
+int scheme_generate_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Object *rand, Scheme_Object *rand2, 
+			  int orig_args, int arith, int cmp, int v, 
+                          Branch_Info *for_branch, int branch_short,
+                          int unsafe_fx, int unsafe_fl, GC_CAN_IGNORE jit_insn *overflow_refslow,
+                          int dest)
+{
+  return scheme_generate_arith_for(jitter, rator, rand, rand2, 
+                                   orig_args, arith, cmp, v, 
+                                   for_branch, branch_short,
+                                   unsafe_fx, unsafe_fl, overflow_refslow,
+                                   dest, 0);
+}
+
+int scheme_generate_extflonum_arith(mz_jit_state *jitter, Scheme_Object *rator, Scheme_Object *rand, Scheme_Object *rand2, 
+                                    int orig_args, int arith, int cmp, int v, 
+                                    Branch_Info *for_branch, int branch_short,
+                                    int unsafe_fx, int unsafe_extfl, GC_CAN_IGNORE jit_insn *overflow_refslow,
+                                    int dest)
+{
+  return scheme_generate_arith_for(jitter, rator, rand, rand2, 
+                                   orig_args, arith, cmp, v, 
+                                   for_branch, branch_short,
+                                   unsafe_fx, unsafe_extfl, overflow_refslow,
+                                   dest, 1);
+}
+
+
 #define MAX_NON_SIMPLE_ARGS 5
 
 static int extract_nary_arg(int reg, int n, mz_jit_state *jitter, Scheme_App_Rec *app, 
diff --git a/src/racket/src/numstr.c b/src/racket/src/numstr.c
index dd78a03..ae14173 100644
--- a/src/racket/src/numstr.c
+++ b/src/racket/src/numstr.c
@@ -67,10 +67,10 @@ READ_ONLY static char *not_a_number_str = "+nan.0";
 READ_ONLY static char *other_not_a_number_str = "-nan.0";
 
 #ifdef MZ_LONG_DOUBLE
-READ_ONLY static char *long_infinity_str = "+inf.l";
-READ_ONLY static char *long_minus_infinity_str = "-inf.l";
-READ_ONLY static char *long_not_a_number_str = "+nan.l";
-READ_ONLY static char *long_other_not_a_number_str = "-nan.l";
+READ_ONLY static char *long_infinity_str = "+inf.t";
+READ_ONLY static char *long_minus_infinity_str = "-inf.t";
+READ_ONLY static char *long_not_a_number_str = "+nan.t";
+READ_ONLY static char *long_other_not_a_number_str = "-nan.t";
 #endif
 /* Single-precision float literals.
    Due to the structure of the reader, they have to be exactly 6
@@ -815,7 +815,8 @@ Scheme_Object *scheme_read_number(const mzchar *str, intptr_t len,
 			   || (ch == 's') || (ch == 'S') \
 			   || (ch == 'f') || (ch == 'F') \
 			   || (ch == 'd') || (ch == 'D') \
-			   || (ch == 'l') || (ch == 'L'))
+			   || (ch == 'l') || (ch == 'L')  \
+			   || (ch == 't') || (ch == 'T')) 
 
 #define isAdigit(ch) ((ch >= '0') && (ch <= '9'))
 
@@ -1199,7 +1200,7 @@ Scheme_Object *scheme_read_number(const mzchar *str, intptr_t len,
 #ifdef MZ_LONG_DOUBLE
   if (has_expt && str[has_expt]) {
     is_long_double = str[has_expt];
-    is_long_double = ((is_long_double == 'l') || (is_long_double == 'L'));
+    is_long_double = ((is_long_double == 't') || (is_long_double == 'T'));
   } else {
     is_long_double = 0;
   }
@@ -1896,9 +1897,9 @@ char *scheme_long_double_to_string (long double d, char* s, int slen, int was_si
   else if (d == 0.0L) {
     /* Check for -0.0, since some printers get it wrong. */
     if (scheme_long_minus_zero_p(d))
-	s = "-0.0l0";
+	s = "-0.0t0";
     else
-	s = "0.0l0";
+	s = "0.0t0";
   } else {
     /* Initial count for significant digits is 14 (double) or 6 digits
        (single). That's big enough to get most right, small enough to
@@ -1940,7 +1941,7 @@ char *scheme_long_double_to_string (long double d, char* s, int slen, int was_si
       l += 2;
     }
 
-     /* Add the l0 suffix (or
+     /* Add the t0 suffix (or
         replace the existing e exponent separator) to cause the
 	 string to be read back as a extended precision float. */
       for (i = 0; i < l; i++) {
@@ -1948,12 +1949,12 @@ char *scheme_long_double_to_string (long double d, char* s, int slen, int was_si
 	  break;
       }
       if (i == l) {
-	buffer[l] = 'l';
+	buffer[l] = 't';
 	buffer[l + 1] = '0';
 	buffer[l + 2] = 0;
 	l += 2;
       } else {
-	buffer[i] = 'l';
+	buffer[i] = 't';
       }
 
     *used_buffer = 1;